'use strict';

var _satelliteManager = require('../server/managers/satelliteManager');

var _satelliteManager2 = _interopRequireDefault(_satelliteManager);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _require = require('./Help'),
    Help = _require.Help;

var Comsat = function Comsat(args) {
  var _this = this;

  _classCallCheck(this, Comsat);

  this.run = function () {
    if (!_this.args.length) {
      Help.displayComsatCommandHelp();
    } else {
      runCommand(_this.args);
    }
  };

  this.args = args;
};

function runCommand(args) {
  switch (args[0]) {
    case '-list':
      return runListCommand(args);
    case '-add':
      return runAddCommand(args);
    case '-remove':
      return runRemoveCommand(args);
    default:
      Help.displayComsatCommandHelp();
  }
}

function runListCommand(args) {
  if (args.length > 1) return Help.displayExtraArgumentHelp(args[1]);

  try {
    _satelliteManager2.default.list();
  } catch (e) {
    console.log(e);
  }
}

function runAddCommand(args) {
  if (args.length < 4) return Help.displayComsatAddHelp();
  if (args.length > 5) return Help.displayExtraArgumentHelp(args[5]);

  try {
    _satelliteManager2.default.createSatellite(args[1], args[2], args[3], args[4]);
  } catch (e) {
    console.log(e);
  }
}

function runRemoveCommand(args) {
  if (args.length > 2) return Help.displayExtraArgumentHelp(args[2]);

  try {
    _satelliteManager2.default.removeSatellite(args[1]);
  } catch (e) {
    console.log(e);
  }
}

exports.Comsat = Comsat;