'use strict';

var _fogControllerConfigService = require('../server/services/fogControllerConfigService');

var _fogControllerConfigService2 = _interopRequireDefault(_fogControllerConfigService);

var _fogControllerConfigManager = require('../server/managers/fogControllerConfigManager');

var _fogControllerConfigManager2 = _interopRequireDefault(_fogControllerConfigManager);

var _configUtil = require('../server/utils/configUtil');

var _configUtil2 = _interopRequireDefault(_configUtil);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _require = require('./Help'),
    Help = _require.Help;

var Config = function Config(args) {
  var _this = this;

  _classCallCheck(this, Config);

  this.run = function () {
    if (!_this.args.length) {
      Help.displayConfigCommandHelp();
    } else {
      runCommand(_this.args);
    }
  };

  this.args = args;
};

function runCommand(args) {
  switch (args[0]) {
    case '-list':
      return runListCommand(args);
    case '-add':
      return runAddCommand(args);
    case '-remove':
      return runRemoveCommand(args);
    default:
      Help.displayExtraArgumentHelp(args[0]);
  }
}

function runListCommand(args) {
  if (args[1]) {
    Help.displayExtraArgumentHelp(args[1]);
  } else {
    _fogControllerConfigService2.default.configList();
  }
}

function runAddCommand(args) {
  if (args.length < 3) return Help.displayConfigListHelp();
  if (args.length > 3) return Help.displayExtraArgumentHelp(args[3]);

  try {
    _configUtil2.default.setConfigParam(args[1].toLowerCase(), args[2]);
  } catch (e) {
    console.log(e);
  }
}

function runRemoveCommand(args) {
  if (args.length < 2) return Help.displayConfigRemoveHelp();
  if (args.length > 2) return Help.displayExtraArgumentHelp(args[2]);

  try {
    _fogControllerConfigManager2.default.deleteConfig(args[1].toLowerCase());
  } catch (e) {
    console.log(e);
  }
}

exports.Config = Config;