"use strict";

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Help = function Help() {
  _classCallCheck(this, Help);
};

Help.displayExtraArgumentHelp = function (arg) {
  console.log("\n      \tUnrecognized command: " + arg + "\n      \tUse fog-controller help for more information");
};

Help.displayConfigCommandHelp = function () {
  Help.displayConfigListHelp();
  Help.displayConfigAddHelp();
  Help.displayConfigRemoveHelp();
};

Help.displayConfigListHelp = function () {
  console.log("\t\t\t-list\t\t\t\t\t\tDisplays Configuration information in CLI (config table content)");
};

Help.displayConfigAddHelp = function () {
  console.log("\t\t\t-add <key> <value>\t\t\t\tSet Configurations of fog-controller\n                  \t\t\t\t\t\t\t\t(You can set one of these configurations: port, ssl_key, intermediate_cert, ssl_cert,\n                  \t\t\t\t\t\t\t\temail_address, email_password, email_service, ioauthoring_port, ioauthoring_ip_address,\n                  \t\t\t\t\t\t\t\tioauthoring_protocal)");
};

Help.displayConfigRemoveHelp = function () {
  console.log("\t\t\t-remove <key>\t\t\t\t\tDeletes a Configuration with corresponding Key");
};

Help.displayUserCommandHelp = function () {
  Help.displayUserListHelp();
  Help.displayUserAddHelp();
  Help.displayUserRemoveHelp();
  Help.displayUserGenerateTokenHelp();
};

Help.displayUserListHelp = function () {
  console.log("\t\t\t-list\t\t\t\t\t\tList down all users");
};

Help.displayUserAddHelp = function () {
  console.log("\t\t\t-add <email> <firstName> <lastName> <password>\tCreates a new user");
};

Help.displayUserRemoveHelp = function () {
  console.log("\t\t\t-remove <email>\t\t\t\t\tDeletes a user with corresponding email");
};

Help.displayUserGenerateTokenHelp = function () {
  console.log("\t\t\t-generateToken <email>\t\t\t\tResets User Access Token of corresponding email");
};

Help.displayComsatCommandHelp = function () {
  Help.displayComsatListHelp();
  Help.displayComsatAddHelp();
  Help.displayComsatRemoveHelp();
};

Help.displayComsatListHelp = function () {
  console.log("\t\t\t-list\t\t\t\t\t\tList down all ComSat(s)");
};

Help.displayComsatAddHelp = function () {
  console.log("\t\t\t-add <name> <domain> <publicIP> [<certFile>]\tCreates a new ComSat");
};

Help.displayComsatRemoveHelp = function () {
  console.log("\t\t\t-remove <ID>\t\t\t\t\tDeletes a ComSat with corresponding ID");
};

Help.displayGeneralHelp = function () {
  displayHelpHeader();
  console.log("\tconfig");
  Help.displayConfigListHelp();
  Help.displayConfigAddHelp();
  Help.displayConfigRemoveHelp();
  console.log("\tcomsat");
  Help.displayComsatListHelp();
  Help.displayComsatAddHelp();
  Help.displayComsatRemoveHelp();
  console.log("\tuser");
  Help.displayUserListHelp();
  Help.displayUserAddHelp();
  Help.displayUserRemoveHelp();
  Help.displayUserGenerateTokenHelp();
  displayHelpFooter();
};

function displayHelpHeader() {
  console.log("\tUsage 1: fog-controller [OPTION]\n      \tUsage 2: fog-controller [COMMAND] <Argument>\n      \tUsage 3: fog-controller [COMMAND] <key> <value>\n      \n\n      \tCommand\t\tArguments\t\t\t\t\tMeaning\n      \t=======\t\t=========\t\t\t\t\t=======");
}

function displayHelpFooter() {
  console.log("\thelp\t\t\t\t\t\t\t\tShows this message\n  \tstart\t\t\t\t\t\t\t\tStarts fog-controller\n  \tstatus\t\t\t\t\t\t\t\tShows status of fog-controller\n  \tstop\t\t\t\t\t\t\t\tStops fog-controller\n  \tversion\t\t\t\t\t\t\t\tDisplays Version and License\n  \n\n  \tReport bugs to: bugs@iotracks.com\n  \tioFog home page: http://iofog.com\n  \tFor users with Eclipse accounts, report bugs to: https://bugs.eclipse.org/bugs/enter_bug.cgi?product=iofog\n  ");
}

exports.Help = Help;