'use strict';

var _comsatService = require('../server/services/comsatService');

var _comsatService2 = _interopRequireDefault(_comsatService);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var path = require('path');
var fs = require('fs');

var Status = function Status() {
  _classCallCheck(this, Status);
};

Status.display = function (daemon) {
  displayDaemonStatus(daemon);
  displayDatabaseStatus();
};

function displayDaemonStatus(daemon) {
  var pid = daemon.status();
  if (pid === 0) {
    console.log('Fog-Controller is not running.');
  } else {
    console.log('Fog-Controller is running at pid:' + pid);
    displayMemoryStatus();
  }
}

function displayMemoryStatus() {
  var memoryUsed = process.memoryUsage();
  console.log("Memory consumed in RAM by Fog-Controller: " + Math.round(memoryUsed.rss / 1024 / 1024 * 100) / 100 + " MB");
}

function displayDatabaseStatus() {
  try {
    var databaseFileStats = fs.statSync(path.join(__dirname, '../../db/fog_controller.db'));
    console.log('Size of database file: ' + databaseFileStats.size / 1024 + ' KB');
  } catch (e) {
    console.log('Error: "fog_controller.db" not found in "db" folder. ' + e);
  }
  try {
    _comsatService2.default.checkConnectionToComsat();
  } catch (e) {
    console.log('Error: "fail to check connection to comsat ' + e);
  }
}

exports.Status = Status;