'use strict';

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _require = require('./Version'),
    Version = _require.Version;

var _require2 = require('./Config'),
    Config = _require2.Config;

var _require3 = require('./Status'),
    Status = _require3.Status;

var _require4 = require('./Start'),
    Start = _require4.Start;

var _require5 = require('./User'),
    User = _require5.User;

var _require6 = require('./Comsat'),
    Comsat = _require6.Comsat;

var _require7 = require('./Help'),
    Help = _require7.Help;

var CLI = function CLI(args) {
  var _this = this;

  _classCallCheck(this, CLI);

  this.run = function (daemon) {
    switch (_this.args[0]) {
      case 'version':
        return Version.display(_this.args);
      case 'config':
        var config = new Config(_this.args.slice(1));
        return config.run();
      case 'status':
        return Status.display(daemon);
      case 'start':
        return Start.run(daemon);
      case 'stop':
        return daemon.stop();
      case 'user':
        var user = new User(_this.args.slice(1));
        return user.run();
      case 'comsat':
        var comsat = new Comsat(_this.args.slice(1));
        return comsat.run();
      case 'help':
      default:
        Help.displayGeneralHelp();
    }
  };

  this.args = args;
};

exports.CLI = CLI;