#!/usr/bin/env node
'use strict';

var _fogControllerConfigService = require('./server/services/fogControllerConfigService');

var _fogControllerConfigService2 = _interopRequireDefault(_fogControllerConfigService);

var _comsatService = require('./server/services/comsatService');

var _comsatService2 = _interopRequireDefault(_comsatService);

var _fogControllerConfigManager = require('./server/managers/fogControllerConfigManager');

var _fogControllerConfigManager2 = _interopRequireDefault(_fogControllerConfigManager);

var _satelliteManager = require('./server/managers/satelliteManager');

var _satelliteManager2 = _interopRequireDefault(_satelliteManager);

var _userManager = require('./server/managers/userManager');

var _userManager2 = _interopRequireDefault(_userManager);

var _server = require('./server');

var _server2 = _interopRequireDefault(_server);

var _configUtil = require('./server/utils/configUtil');

var _configUtil2 = _interopRequireDefault(_configUtil);

var _constants = require('./server/constants.js');

var _constants2 = _interopRequireDefault(_constants);

var _winstonLogs = require('./server/utils/winstonLogs');

var _winstonLogs2 = _interopRequireDefault(_winstonLogs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var path = require('path');
var fs = require('fs');

var _require = require('./cli'),
    CLI = _require.CLI;

function main() {
    var key = void 0,
        value = void 0,
        args = process.argv.slice(2),
        commandInserted = args.join(' ');

    var cli = new CLI(args);

    var daemon = require("daemonize2").setup({
        main: "daemonServer.js",
        name: "fog-controller",
        pidfile: "fog-controller.pid",
        silent: true
    });

    daemon.on("starting", function () {
        console.log("Starting fog-controller...");
    }).on("stopping", function () {
        console.log("Stopping fog-controller...");
    }).on("stopped", function (pid) {
        console.log("fog-controller stopped.");
    }).on("running", function (pid) {
        console.log("fog-controller already running. PID: " + pid);
    }).on("notrunning", function () {
        console.log("fog-controller is not running");
    }).on("error", function (err) {
        console.log("fog-controller failed to start:  " + err.message);
    });

    _winstonLogs2.default.info('Command inserted: fog-controller ' + commandInserted);

    cli.run(daemon);
}

main();