'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _async = require('async');

var _async2 = _interopRequireDefault(_async);

var _baseApiController = require('./baseApiController');

var _baseApiController2 = _interopRequireDefault(_baseApiController);

var _registryService = require('../../services/registryService');

var _registryService2 = _interopRequireDefault(_registryService);

var _appUtils = require('../../utils/appUtils');

var _appUtils2 = _interopRequireDefault(_appUtils);

var _winstonLogs = require('../../utils/winstonLogs');

var _winstonLogs2 = _interopRequireDefault(_winstonLogs);

var _fogAccessTokenService = require('../../services/fogAccessTokenService');

var _fogAccessTokenService2 = _interopRequireDefault(_fogAccessTokenService);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/********************************************* EndPoints ******************************************************/

/********* Instance Registries EndPoint (Get/Post: /api/v2/instance/registries/id/:ID/token/:Token) **********/
/**
 * @file instanceRegistriesController.js
 * @author Zishan Iqbal
 * @description This file includes the implementation of the instance-registries end-point
 */
var instanceRegistriesEndPoint = function instanceRegistriesEndPoint(req, res) {
    _winstonLogs2.default.info("Endpoint hit: " + req.originalUrl);
    var params = {},
        instanceProps = {
        token: 'bodyParams.Token',
        fogId: 'bodyParams.ID',
        setProperty: 'fogAccessToken'
    },
        regProps = {
        userId: 'fogAccessToken.userId',
        setProperty: 'registry'
    };

    params.bodyParams = req.params;
    _winstonLogs2.default.info("Parameters:" + JSON.stringify(params.bodyParams));

    _async2.default.waterfall([_async2.default.apply(_baseApiController2.default.checkUserExistance, req, res), _async2.default.apply(_fogAccessTokenService2.default.findFogAccessTokenByTokenAndFogId, instanceProps, params), _async2.default.apply(_registryService2.default.findRegistriesByUserId, regProps, params)], function (err, result) {
        _appUtils2.default.sendResponse(res, err, 'registries', params.registry, result);
    });
};

exports.default = {
    instanceRegistriesEndPoint: instanceRegistriesEndPoint
};