'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _async = require('async');

var _async2 = _interopRequireDefault(_async);

var _changeTrackingService = require('../../services/changeTrackingService');

var _changeTrackingService2 = _interopRequireDefault(_changeTrackingService);

var _comsatService = require('../../services/comsatService');

var _comsatService2 = _interopRequireDefault(_comsatService);

var _consoleService = require('../../services/consoleService');

var _consoleService2 = _interopRequireDefault(_consoleService);

var _elementService = require('../../services/elementService');

var _elementService2 = _interopRequireDefault(_elementService);

var _elementInstancePortService = require('../../services/elementInstancePortService');

var _elementInstancePortService2 = _interopRequireDefault(_elementInstancePortService);

var _elementInstanceService = require('../../services/elementInstanceService');

var _elementInstanceService2 = _interopRequireDefault(_elementInstanceService);

var _fogService = require('../../services/fogService');

var _fogService2 = _interopRequireDefault(_fogService);

var _fogTypeService = require('../../services/fogTypeService');

var _fogTypeService2 = _interopRequireDefault(_fogTypeService);

var _fogUserService = require('../../services/fogUserService');

var _fogUserService2 = _interopRequireDefault(_fogUserService);

var _networkPairingService = require('../../services/networkPairingService');

var _networkPairingService2 = _interopRequireDefault(_networkPairingService);

var _satelliteService = require('../../services/satelliteService');

var _satelliteService2 = _interopRequireDefault(_satelliteService);

var _satellitePortService = require('../../services/satellitePortService');

var _satellitePortService2 = _interopRequireDefault(_satellitePortService);

var _streamViewerService = require('../../services/streamViewerService');

var _streamViewerService2 = _interopRequireDefault(_streamViewerService);

var _userService = require('../../services/userService');

var _userService2 = _interopRequireDefault(_userService);

var _appUtils = require('../../utils/appUtils');

var _appUtils2 = _interopRequireDefault(_appUtils);

var _winstonLogs = require('../../utils/winstonLogs');

var _winstonLogs2 = _interopRequireDefault(_winstonLogs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @deprecated
 */

/********************************************* EndPoints ******************************************************/

/*************** Integrator Instance Create EndPoint (Post: /api/v2/authoring/integrator/instance/create     
                                                          : /api/v2/authoring/fabric/instance/create) ************/
var integratorInstanceCreateEndPoint = function integratorInstanceCreateEndPoint(req, res) {
  _winstonLogs2.default.info("Endpoint hit: " + req.originalUrl);
  var params = {},
      userProps = {
    userId: 'bodyParams.t',
    setProperty: 'user'
  },
      createFogProps = {
    name: 'bodyParams.name',
    location: 'bodyParams.location',
    latitude: 'bodyParams.latitude',
    longitude: 'bodyParams.longitude',
    description: 'bodyParams.description',
    fogType: 'bodyParams.fabricType',
    setProperty: 'fogInstance'
  },
      createFogUserProps = {
    userId: 'user.id',
    instanceId: 'fogInstance.uuid',
    setProperty: null
  },
      fogTypeProps = {
    fogTypeId: 'bodyParams.fabricType',
    setProperty: 'fogType'
  },
      createChangeTrackingProps = {
    fogInstanceId: 'fogInstance.uuid',
    setProperty: null
  };

  params.bodyParams = req.body;
  _winstonLogs2.default.info("Parameters:" + JSON.stringify(params.bodyParams));

  _async2.default.waterfall([_async2.default.apply(_userService2.default.getUser, userProps, params), _async2.default.apply(_fogTypeService2.default.getFogTypeDetail, fogTypeProps), _async2.default.apply(_fogService2.default.createFogInstance, createFogProps), _async2.default.apply(_changeTrackingService2.default.createFogChangeTracking, createChangeTrackingProps), _async2.default.apply(_fogUserService2.default.createFogUser, createFogUserProps)], function (err, result) {

    _appUtils2.default.sendResponse(res, err, 'instance', params.fogInstance, result);
  });
};

/*********** Integrator Instance Update EndPoint (Post: /api/v2/authoring/integrator/instance/update) *********/
/**
 * @file IntegratorController.js
 * @author Zishan Iqbal
 * @description This file includes the implementation of the Integrator instance
 */
var integratorInstanceUpdateEndPoint = function integratorInstanceUpdateEndPoint(req, res) {
  _winstonLogs2.default.info("Endpoint hit: " + req.originalUrl);
  var params = {},
      userProps = {
    userId: 'bodyParams.t',
    setProperty: 'user'
  },
      fogInstanceProps = {
    fogId: 'bodyParams.instanceId',
    setProperty: 'fogInstance'
  };

  params.bodyParams = req.body;
  _winstonLogs2.default.info("Parameters:" + JSON.stringify(params.bodyParams));

  _async2.default.waterfall([_async2.default.apply(_userService2.default.getUser, userProps, params), _async2.default.apply(_fogService2.default.getFogInstance, fogInstanceProps), updateFogInstance], function (err, result) {
    var errMsg = 'Internal error: There was a problem updating Fog instance.' + result;
    _appUtils2.default.sendResponse(res, err, 'instanceId', params.bodyParams.instanceId, errMsg);
  });
};

/************************************* Extra Functions **************************************************/
var updateFogInstance = function updateFogInstance(params, callback) {
  var fogInstanceProps = {
    instanceId: 'bodyParams.instanceId',
    updatedFog: {
      name: params.bodyParams.name,
      location: params.bodyParams.location,
      latitude: params.bodyParams.latitude,
      longitude: params.bodyParams.longitude,
      description: params.bodyParams.description
    }
  };
  _fogService2.default.updateFogInstance(fogInstanceProps, params, callback);
};

exports.default = {
  integratorInstanceCreateEndPoint: integratorInstanceCreateEndPoint,
  integratorInstanceUpdateEndPoint: integratorInstanceUpdateEndPoint
};