'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _baseManager = require('./../managers/baseManager');

var _baseManager2 = _interopRequireDefault(_baseManager);

var _fogConsole = require('./../models/fogConsole');

var _fogConsole2 = _interopRequireDefault(_fogConsole);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @file consoleManager.js
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @author Zishan Iqbal
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @description This file includes the CURD operations for the fogConsole Model.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

var FogConsoleManager = function (_BaseManager) {
	_inherits(FogConsoleManager, _BaseManager);

	function FogConsoleManager() {
		_classCallCheck(this, FogConsoleManager);

		return _possibleConstructorReturn(this, (FogConsoleManager.__proto__ || Object.getPrototypeOf(FogConsoleManager)).apply(this, arguments));
	}

	_createClass(FogConsoleManager, [{
		key: 'getEntity',
		value: function getEntity() {
			return _fogConsole2.default;
		}
		/**
   * @desc - finds the fogConsole based on the instanceId
   * @param Integer - instanceId
   * @return JSON - returns a JSON object of fogConsole
   */

	}, {
		key: 'findByInstanceId',
		value: function findByInstanceId(instanceId) {
			return _fogConsole2.default.find({
				where: {
					iofog_uuid: instanceId
				}
			});
		}

		/**
   * @desc - deletes the console based on the instanceId
   * @param String - instanceId
   * @return  Integer - returns the number of rows deleted
   */

	}, {
		key: 'deleteByInstanceId',
		value: function deleteByInstanceId(instanceId) {
			return _fogConsole2.default.destroy({
				where: {
					iofog_uuid: instanceId
				}
			});
		}
	}]);

	return FogConsoleManager;
}(_baseManager2.default);

var instance = new FogConsoleManager();
exports.default = instance;