'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _baseManager = require('./../managers/baseManager');

var _baseManager2 = _interopRequireDefault(_baseManager);

var _dataTracks = require('./../models/dataTracks');

var _dataTracks2 = _interopRequireDefault(_dataTracks);

var _sequelize = require('./../utils/sequelize');

var _sequelize2 = _interopRequireDefault(_sequelize);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @file dataTracksManager.js
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @author Zishan Iqbal
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @description This file includes the CURD operations for the dataTracks Model.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

var DataTracksManager = function (_BaseManager) {
    _inherits(DataTracksManager, _BaseManager);

    function DataTracksManager() {
        _classCallCheck(this, DataTracksManager);

        return _possibleConstructorReturn(this, (DataTracksManager.__proto__ || Object.getPrototypeOf(DataTracksManager)).apply(this, arguments));
    }

    _createClass(DataTracksManager, [{
        key: 'getEntity',
        value: function getEntity() {
            return _dataTracks2.default;
        }
    }, {
        key: 'findByInstanceId',
        value: function findByInstanceId(instanceId) {
            return _dataTracks2.default.findAll({
                where: {
                    instanceId: instanceId
                },
                attributes: ['id', 'name', 'description']
            });
        }
    }, {
        key: 'findById',
        value: function findById(trackId) {
            return _dataTracks2.default.findOne({
                where: {
                    id: trackId
                }
            });
        }
    }, {
        key: 'getTracksByUserId',
        value: function getTracksByUserId(userId) {
            return _dataTracks2.default.findAll({
                where: {
                    updatedBy: userId
                }
            });
        }
    }, {
        key: 'deleteByTrackId',
        value: function deleteByTrackId(trackId) {
            return _dataTracks2.default.destroy({
                where: {
                    id: trackId
                }
            });
        }
    }, {
        key: 'updateById',
        value: function updateById(id, data) {
            return _dataTracks2.default.update(data, {
                where: {
                    id: id
                }
            });
        }
    }, {
        key: 'updateByUserId',
        value: function updateByUserId(userId, data) {
            return _dataTracks2.default.update(data, {
                where: {
                    updatedBy: userId
                }
            });
        }
    }, {
        key: 'findContainerListByInstanceId',
        value: function findContainerListByInstanceId(instanceId) {
            var instanceTrackingQuery = "SELECT i.*, t.is_activated FROM element_instance i LEFT JOIN \
    data_tracks t ON i.track_id = t.ID \
    WHERE i.iofog_uuid in (:instanceId) AND (i.track_id = 0 OR t.is_activated = 1)";

            return _sequelize2.default.query(instanceTrackingQuery, {
                replacements: {
                    instanceId: instanceId
                },
                type: _sequelize2.default.QueryTypes.SELECT
            });
        }
    }, {
        key: 'findContainerListWithStatusByInstanceId',
        value: function findContainerListWithStatusByInstanceId(instanceId) {
            var instanceTrackingQuery = "SELECT i.*, t.is_activated, s.* FROM element_instance i \
    LEFT JOIN data_tracks t ON i.track_id = t.ID \
    LEFT JOIN element_instance_status s ON i.uuid = s.element_instance_uuid \
    WHERE i.iofog_uuid in (:instanceId) AND (i.track_id = 0 OR t.is_activated = 1)";

            return _sequelize2.default.query(instanceTrackingQuery, {
                replacements: {
                    instanceId: instanceId
                },
                type: _sequelize2.default.QueryTypes.SELECT
            });
        }
    }, {
        key: 'findActiveElementInstanceUUIDs',
        value: function findActiveElementInstanceUUIDs(elementInstanceId) {
            var query = "select ei.UUID from element_instance ei join data_tracks dt where ei.UUID=:elementInstanceId \
        and (dt.is_activated=1 or ei.track_id==0)";

            return _sequelize2.default.query(query, {
                replacements: {
                    elementInstanceId: elementInstanceId
                },
                type: _sequelize2.default.QueryTypes.SELECT
            });
        }
    }]);

    return DataTracksManager;
}(_baseManager2.default);

var instance = new DataTracksManager();
exports.default = instance;