'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _elementImage = require('../models/elementImage');

var _elementImage2 = _interopRequireDefault(_elementImage);

var _baseManager = require('./baseManager');

var _baseManager2 = _interopRequireDefault(_baseManager);

var _element = require('../models/element');

var _element2 = _interopRequireDefault(_element);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @file ioElementImageManager.js
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @author Zishan Iqbal
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @description This file includes the CURD operations for the ioElementImage Model.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

var ElementImageManager = function (_BaseManager) {
    _inherits(ElementImageManager, _BaseManager);

    function ElementImageManager() {
        _classCallCheck(this, ElementImageManager);

        return _possibleConstructorReturn(this, (ElementImageManager.__proto__ || Object.getPrototypeOf(ElementImageManager)).apply(this, arguments));
    }

    _createClass(ElementImageManager, [{
        key: 'getEntity',
        value: function getEntity() {
            return _elementImage2.default;
        }
    }, {
        key: 'createElementImage',
        value: function createElementImage(FogTypeObj) {
            return _elementImage2.default.create(FogTypeObj);
        }
    }, {
        key: 'getElementImagesByElementId',
        value: function getElementImagesByElementId(elementId) {
            return _elementImage2.default.findAll({
                where: {
                    element_id: elementId
                }
            });
        }
    }, {
        key: 'updateElementImageByIdAndFogType',
        value: function updateElementImageByIdAndFogType(data) {
            return _elementImage2.default.update(data, {
                where: {
                    element_id: data.element_id,
                    iofog_type_id: data.iofog_type_id
                }
            });
        }
    }, {
        key: 'updateOrCreateElementImageByIdAndFogType',
        value: function updateOrCreateElementImageByIdAndFogType(data) {
            return _elementImage2.default.findOne({
                where: {
                    element_id: data.element_id,
                    iofog_type_id: data.iofog_type_id
                }
            }).then(function (obj) {
                if (obj) {
                    // update
                    return _elementImage2.default.update(data, {
                        where: {
                            element_id: data.element_id,
                            iofog_type_id: data.iofog_type_id
                        }
                    });
                } else {
                    // insert
                    return _elementImage2.default.create(data);
                }
            });
        }
    }, {
        key: 'deleteElementImage',
        value: function deleteElementImage(elementId) {
            return _elementImage2.default.destroy({
                where: {
                    element_id: elementId
                }
            });
        }
    }]);

    return ElementImageManager;
}(_baseManager2.default);

var instance = new ElementImageManager();
exports.default = instance;