'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _elementInputType = require('./../models/elementInputType');

var _elementInputType2 = _interopRequireDefault(_elementInputType);

var _baseManager = require('./../managers/baseManager');

var _baseManager2 = _interopRequireDefault(_baseManager);

var _sequelize = require('./../utils/sequelize');

var _sequelize2 = _interopRequireDefault(_sequelize);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @file fogManager.js
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @author Zishan Iqbal
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @description This file includes the CURD operations for the element_input_type Model.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

var ElementInputTypeManager = function (_BaseManager) {
  _inherits(ElementInputTypeManager, _BaseManager);

  function ElementInputTypeManager() {
    _classCallCheck(this, ElementInputTypeManager);

    return _possibleConstructorReturn(this, (ElementInputTypeManager.__proto__ || Object.getPrototypeOf(ElementInputTypeManager)).apply(this, arguments));
  }

  _createClass(ElementInputTypeManager, [{
    key: 'getEntity',
    value: function getEntity() {
      return _elementInputType2.default;
    }
  }, {
    key: 'findByElementKey',
    value: function findByElementKey(elementKey) {
      return _elementInputType2.default.find({
        where: {
          elementKey: elementKey
        }
      });
    }
  }, {
    key: 'updateElementInputType',
    value: function updateElementInputType(elementKey, info) {
      return _elementInputType2.default.update(info, {
        where: {
          elementKey: elementKey
        }
      });
    }
  }, {
    key: 'createElementInputType',
    value: function createElementInputType(data) {
      return _elementInputType2.default.create(data);
    }
  }, {
    key: 'deleteByElementKey',
    value: function deleteByElementKey(elementKey) {
      return _elementInputType2.default.destroy({
        where: {
          elementKey: elementKey
        }
      });
    }
  }]);

  return ElementInputTypeManager;
}(_baseManager2.default);

var instance = new ElementInputTypeManager();
exports.default = instance;