'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _baseManager = require('./../managers/baseManager');

var _baseManager2 = _interopRequireDefault(_baseManager);

var _elementInstanceConnections = require('./../models/elementInstanceConnections');

var _elementInstanceConnections2 = _interopRequireDefault(_elementInstanceConnections);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ElementInstanceConnectionsManager = function (_BaseManager) {
  _inherits(ElementInstanceConnectionsManager, _BaseManager);

  function ElementInstanceConnectionsManager() {
    _classCallCheck(this, ElementInstanceConnectionsManager);

    return _possibleConstructorReturn(this, (ElementInstanceConnectionsManager.__proto__ || Object.getPrototypeOf(ElementInstanceConnectionsManager)).apply(this, arguments));
  }

  _createClass(ElementInstanceConnectionsManager, [{
    key: 'getEntity',
    value: function getEntity() {
      return _elementInstanceConnections2.default;
    }
  }, {
    key: 'findBySourceElementInstance',
    value: function findBySourceElementInstance(instanceId) {
      return _elementInstanceConnections2.default.findAll({
        where: {
          source_element_instance: instanceId
        }
      });
    }
  }, {
    key: 'findBySourceAndDestinationElementInstance',
    value: function findBySourceAndDestinationElementInstance(sourceElementInstanceId, destinationElementInstanceId) {
      return _elementInstanceConnections2.default.findAll({
        where: {
          sourceElementInstance: sourceElementInstanceId,
          destinationElementInstance: destinationElementInstanceId
        }
      });
    }
  }, {
    key: 'deleteElementInstanceConnection',
    value: function deleteElementInstanceConnection(elementId) {
      return _elementInstanceConnections2.default.destroy({
        where: {
          $or: [{
            sourceElementInstance: elementId
          }, {
            destinationElementInstance: elementId
          }]
        }
      });
    }
  }, {
    key: 'deleteBySourceAndDestinationElementInstance',
    value: function deleteBySourceAndDestinationElementInstance(sourceElementInstanceId, destinationElementInstanceId) {
      return _elementInstanceConnections2.default.destroy({
        where: {
          sourceElementInstance: sourceElementInstanceId,
          destinationElementInstance: destinationElementInstanceId
        }
      });
    }
  }]);

  return ElementInstanceConnectionsManager;
}(_baseManager2.default);

var instance = new ElementInstanceConnectionsManager();
exports.default = instance;