'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _elementInstancePort = require('./../models/elementInstancePort');

var _elementInstancePort2 = _interopRequireDefault(_elementInstancePort);

var _baseManager = require('./../managers/baseManager');

var _baseManager2 = _interopRequireDefault(_baseManager);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @file elementInstancePortManager.js
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @author Zishan Iqbal
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @description This file includes the CURD operations for the elementInstancePort Model.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

var ElementInstancePortManager = function (_BaseManager) {
	_inherits(ElementInstancePortManager, _BaseManager);

	function ElementInstancePortManager() {
		_classCallCheck(this, ElementInstancePortManager);

		return _possibleConstructorReturn(this, (ElementInstancePortManager.__proto__ || Object.getPrototypeOf(ElementInstancePortManager)).apply(this, arguments));
	}

	_createClass(ElementInstancePortManager, [{
		key: 'getEntity',
		value: function getEntity() {
			return _elementInstancePort2.default;
		}
	}, {
		key: 'getPortsByElementId',
		value: function getPortsByElementId(elementId) {
			return _elementInstancePort2.default.findAll({
				where: {
					elementId: elementId
				}
			});
		}
	}, {
		key: 'createElementPort',
		value: function createElementPort(userId, elementId, portExternal, portInternal) {
			return _elementInstancePort2.default.create({
				portinternal: portInternal,
				portexternal: portExternal,
				updatedBy: userId,
				elementId: elementId
			});
		}
	}, {
		key: 'findPortsByElementIds',
		value: function findPortsByElementIds(ids) {
			return _elementInstancePort2.default.findAll({
				where: {
					elementId: {
						$in: ids
					}
				}
			});
		}
	}, {
		key: 'deleteByElementInstanceId',
		value: function deleteByElementInstanceId(instanceId) {
			return _elementInstancePort2.default.destroy({
				where: {
					elementId: instanceId
				}
			});
		}
	}]);

	return ElementInstancePortManager;
}(_baseManager2.default);

var instance = new ElementInstancePortManager();
exports.default = instance;