"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _baseManager = require("./baseManager");

var _baseManager2 = _interopRequireDefault(_baseManager);

var _elementInstanceStatus = require("../models/elementInstanceStatus");

var _elementInstanceStatus2 = _interopRequireDefault(_elementInstanceStatus);

var _elementInstanceManager = require("../managers/elementInstanceManager");

var _elementInstanceManager2 = _interopRequireDefault(_elementInstanceManager);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * @author elukashick
 */

var ElementInstanceStatusManager = function (_BaseManager) {
    _inherits(ElementInstanceStatusManager, _BaseManager);

    function ElementInstanceStatusManager() {
        _classCallCheck(this, ElementInstanceStatusManager);

        return _possibleConstructorReturn(this, (ElementInstanceStatusManager.__proto__ || Object.getPrototypeOf(ElementInstanceStatusManager)).apply(this, arguments));
    }

    _createClass(ElementInstanceStatusManager, [{
        key: "getEntity",
        value: function getEntity() {
            return _elementInstanceStatus2.default;
        }
    }, {
        key: "findByInstanceId",
        value: function findByInstanceId(uuid) {
            return _elementInstanceStatus2.default.find({
                where: {
                    element_instance_uuid: uuid
                }
            });
        }
    }, {
        key: "update",
        value: function update(obj) {
            return _elementInstanceStatus2.default.update(obj, {
                where: {
                    element_instance_uuid: obj.uuid
                }
            });
        }
    }, {
        key: "create",
        value: function create(obj) {
            return _elementInstanceStatus2.default.create({
                status: obj.status,
                cpuUsage: obj.cpuUsage,
                memoryUsage: obj.memoryUsage,
                containerId: obj.containerId,
                element_instance_uuid: obj.uuid
            });
        }
    }, {
        key: "upsertStatus",
        value: function upsertStatus(obj) {
            var _this2 = this;

            return _elementInstanceManager2.default.findByUuId(obj.uuid).then(function (elementInstanceObj) {
                return null == elementInstanceObj ? null : _this2.findByInstanceId(obj.uuid).then(function (dbObj) {
                    return null == dbObj ? _this2.create(obj) : _this2.update(obj);
                });
            });
        }
    }]);

    return ElementInstanceStatusManager;
}(_baseManager2.default);

var instance = new ElementInstanceStatusManager();
exports.default = instance;