'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _emailActivationCode = require('./../models/emailActivationCode');

var _emailActivationCode2 = _interopRequireDefault(_emailActivationCode);

var _baseManager = require('./baseManager');

var _baseManager2 = _interopRequireDefault(_baseManager);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @file emailActivationCodes.js
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @author Zishan Iqbal
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @description This file includes the CURD operations for the email_activation_codes Model.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

var EmailActivationCodeManager = function (_BaseManager) {
	_inherits(EmailActivationCodeManager, _BaseManager);

	function EmailActivationCodeManager() {
		_classCallCheck(this, EmailActivationCodeManager);

		return _possibleConstructorReturn(this, (EmailActivationCodeManager.__proto__ || Object.getPrototypeOf(EmailActivationCodeManager)).apply(this, arguments));
	}

	_createClass(EmailActivationCodeManager, [{
		key: 'getEntity',
		value: function getEntity() {
			return _emailActivationCode2.default;
		}
	}, {
		key: 'getByActivationCode',
		value: function getByActivationCode(activationCode) {
			return _emailActivationCode2.default.find({
				where: {
					activationCode: activationCode
				}
			});
		}
	}, {
		key: 'createActivationCode',
		value: function createActivationCode(userId, activationCode, expirationTime) {
			return _emailActivationCode2.default.create({
				user_id: userId,
				activationCode: activationCode,
				expirationTime: expirationTime
			});
		}
	}, {
		key: 'verifyActivationCode',
		value: function verifyActivationCode(activationCode) {
			return _emailActivationCode2.default.find({
				where: {
					activationCode: activationCode,
					expirationTime: {
						$gt: new Date().getTime()
					}
				}
			});
		}
	}]);

	return EmailActivationCodeManager;
}(_baseManager2.default);

var instance = new EmailActivationCodeManager();
exports.default = instance;