'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _fogAccessToken = require('./../models/fogAccessToken');

var _fogAccessToken2 = _interopRequireDefault(_fogAccessToken);

var _baseManager = require('./../managers/baseManager');

var _baseManager2 = _interopRequireDefault(_baseManager);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @file fogAccessTokenManager.js
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @author Zishan Iqbal
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @description This file includes the CURD operations for the fogAccessToken Model.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

var FogAccessTokenManager = function (_BaseManager) {
  _inherits(FogAccessTokenManager, _BaseManager);

  function FogAccessTokenManager() {
    _classCallCheck(this, FogAccessTokenManager);

    return _possibleConstructorReturn(this, (FogAccessTokenManager.__proto__ || Object.getPrototypeOf(FogAccessTokenManager)).apply(this, arguments));
  }

  _createClass(FogAccessTokenManager, [{
    key: 'getEntity',
    value: function getEntity() {
      return _fogAccessToken2.default;
    }
    /**
     * @desc - finds the fogAccessToken based on the token
     * @param String - token
     * @return JSON - returns a JSON object of fogAccessToken
     */

  }, {
    key: 'getByToken',
    value: function getByToken(token) {
      return _fogAccessToken2.default.find({
        where: {
          token: token
        }
      });
    }
  }, {
    key: 'getByTokenAndFogId',
    value: function getByTokenAndFogId(token, fogId) {
      return _fogAccessToken2.default.find({
        where: {
          token: token,
          iofog_uuid: fogId
        }
      });
    }
    /**
     * @desc - deletes the fogAccessToken based on the userId
     * @param Integer - userId
     * @return Integer -  returns the number of rows deleted
     */

  }, {
    key: 'deleteByFogId',
    value: function deleteByFogId(fogId) {
      return _fogAccessToken2.default.destroy({
        where: {
          iofog_uuid: fogId
        }
      });
    }
    /**
     * @desc - creates a new fogAccessToken from the incoming parameters
     * @param Integer, Integer, String  - userId, expiryTokenTime, token
     * @return Integer - returns the number of rows inserted
     */

  }, {
    key: 'saveUserToken',
    value: function saveUserToken(config) {
      return _fogAccessToken2.default.create(config);
    }
  }]);

  return FogAccessTokenManager;
}(_baseManager2.default);

var instance = new FogAccessTokenManager();
exports.default = instance;