'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _baseManager = require('./../managers/baseManager');

var _baseManager2 = _interopRequireDefault(_baseManager);

var _fog = require('./../models/fog');

var _fog2 = _interopRequireDefault(_fog);

var _fogProvisionKey = require('./../models/fogProvisionKey');

var _fogProvisionKey2 = _interopRequireDefault(_fogProvisionKey);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @file fogProvisionKeyManager.js
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @author Zishan Iqbal
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @description This file includes the CURD operations for the fogProvisionKey Model.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var FogProvisionKeyManager = function (_BaseManager) {
  _inherits(FogProvisionKeyManager, _BaseManager);

  function FogProvisionKeyManager() {
    _classCallCheck(this, FogProvisionKeyManager);

    return _possibleConstructorReturn(this, (FogProvisionKeyManager.__proto__ || Object.getPrototypeOf(FogProvisionKeyManager)).apply(this, arguments));
  }

  _createClass(FogProvisionKeyManager, [{
    key: 'createProvisionKey',


    /**
     * @desc - creates a new ProvisionKey with the param data
     * @param JSON object - newProvision
     * @return JSON object - returns the created object
     */
    value: function createProvisionKey(newProvision) {
      return _fogProvisionKey2.default.create(newProvision);
    }
  }, {
    key: 'findByInstanceId',
    value: function findByInstanceId(instanceId) {
      return _fogProvisionKey2.default.find({
        where: {
          iofog_uuid: instanceId
        }
      });
    }

    /**
     * @desc - deletes the fog provision key based on the instanceId
     * @param String - instanceId
     * @return  Integer - returns the number of rows deleted
     */

  }, {
    key: 'deleteByInstanceId',
    value: function deleteByInstanceId(instanceId) {
      return _fogProvisionKey2.default.destroy({
        where: {
          iofog_uuid: instanceId
        }
      });
    }

    /**
       * @desc - removes the provisionKey based on the key from the database
       * @param String - key
       * @return Integer - returns the number of rows deleted
       */

  }, {
    key: 'deleteByProvisionKey',
    value: function deleteByProvisionKey(key) {
      return _fogProvisionKey2.default.destroy({
        where: {
          provisionKey: key
        }
      });
    }
  }, {
    key: 'getEntity',
    value: function getEntity() {
      return _fogProvisionKey2.default;
    }
    /**
     * @desc - finds the provisionKey based on the key parameter
     * @param String - key
     * @return JSON - returns a JSON object of fogProvisionKey including the fog it belongs to
     */

  }, {
    key: 'getByProvisionKey',
    value: function getByProvisionKey(key) {
      return _fogProvisionKey2.default.findOne({
        where: {
          provisionKey: key
        },
        include: [_fog2.default]
      });
    }
  }, {
    key: 'deleteExpiredProvisionKeys',
    value: function deleteExpiredProvisionKeys(pastTime) {
      return _fogProvisionKey2.default.destroy({
        where: {
          expirationTime: {
            $lt: pastTime
          }
        }
      });
    }
  }]);

  return FogProvisionKeyManager;
}(_baseManager2.default);

var instance = new FogProvisionKeyManager();
exports.default = instance;