"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _baseManager = require("./../managers/baseManager");

var _baseManager2 = _interopRequireDefault(_baseManager);

var _fogVersionCommand = require("../models/fogVersionCommand");

var _fogVersionCommand2 = _interopRequireDefault(_fogVersionCommand);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @file fogVersionCommandManager.js
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @author Maksim Chepelev
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @description This file includes the CURD operations for the versionCommand Model.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var FogVersionCommandManager = function (_BaseManager) {
    _inherits(FogVersionCommandManager, _BaseManager);

    function FogVersionCommandManager() {
        _classCallCheck(this, FogVersionCommandManager);

        return _possibleConstructorReturn(this, (FogVersionCommandManager.__proto__ || Object.getPrototypeOf(FogVersionCommandManager)).apply(this, arguments));
    }

    _createClass(FogVersionCommandManager, [{
        key: "createVersionCommand",
        value: function createVersionCommand(newVersionCommand) {
            return _fogVersionCommand2.default.create(newVersionCommand);
        }
    }, {
        key: "findByInstanceId",
        value: function findByInstanceId(instanceId) {
            return _fogVersionCommand2.default.find({
                where: {
                    iofog_uuid: instanceId
                }
            });
        }
    }, {
        key: "deleteByInstanceId",
        value: function deleteByInstanceId(instanceId) {
            return _fogVersionCommand2.default.destroy({
                where: {
                    iofog_uuid: instanceId
                }
            });
        }
    }, {
        key: "getEntity",
        value: function getEntity() {
            return _fogVersionCommand2.default;
        }
    }]);

    return FogVersionCommandManager;
}(_baseManager2.default);

var instance = new FogVersionCommandManager();
exports.default = instance;