'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _instanceTrack = require('./../models/instanceTrack');

var _instanceTrack2 = _interopRequireDefault(_instanceTrack);

var _elementInstance = require('./../models/elementInstance');

var _elementInstance2 = _interopRequireDefault(_elementInstance);

var _baseManager = require('./../managers/baseManager');

var _baseManager2 = _interopRequireDefault(_baseManager);

var _sequelize = require('./../utils/sequelize');

var _sequelize2 = _interopRequireDefault(_sequelize);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @file instanceTrackManager.js
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @author Zishan Iqbal
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @description This file includes the CURD operations for the instanceTrack Model.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

var InstanceTrackManager = function (_BaseManager) {
	_inherits(InstanceTrackManager, _BaseManager);

	function InstanceTrackManager() {
		_classCallCheck(this, InstanceTrackManager);

		return _possibleConstructorReturn(this, (InstanceTrackManager.__proto__ || Object.getPrototypeOf(InstanceTrackManager)).apply(this, arguments));
	}

	_createClass(InstanceTrackManager, [{
		key: 'findInstanceContainer',


		/**
   * @desc - uses a raw-Query to perform a join operation between element_instance and instance_track tables
   * @param Integer - instanceId
   * @return JSON - returns a Array of JSON objects with elementInstance and its related instanceTrack
   */
		value: function findInstanceContainer(instanceId) {
			var instanceTrackingQuery = "SELECT i.*, t.* FROM element_instance i LEFT JOIN \
		instance_track t ON i.track_id = t.ID \
		WHERE i.iofog_uuid in (:instanceId) AND (i.track_id = 0 OR t.is_activated = 1)";

			return _sequelize2.default.query(instanceTrackingQuery, {
				replacements: {
					instanceId: instanceId
				},
				type: _sequelize2.default.QueryTypes.SELECT
			});
		}
	}]);

	return InstanceTrackManager;
}(_baseManager2.default);

var instance = new InstanceTrackManager();
exports.default = instance;