'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _networkPairing = require('./../models/networkPairing');

var _networkPairing2 = _interopRequireDefault(_networkPairing);

var _baseManager = require('./../managers/baseManager');

var _baseManager2 = _interopRequireDefault(_baseManager);

var _sequelize = require('./../utils/sequelize');

var _sequelize2 = _interopRequireDefault(_sequelize);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @file networkPairingManager.js
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @author Zishan Iqbal
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @description
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

var NetworkPairingManager = function (_BaseManager) {
  _inherits(NetworkPairingManager, _BaseManager);

  function NetworkPairingManager() {
    _classCallCheck(this, NetworkPairingManager);

    return _possibleConstructorReturn(this, (NetworkPairingManager.__proto__ || Object.getPrototypeOf(NetworkPairingManager)).apply(this, arguments));
  }

  _createClass(NetworkPairingManager, [{
    key: 'getEntity',
    value: function getEntity() {
      return _networkPairing2.default;
    }
  }, {
    key: 'findByElemen1PortIds',
    value: function findByElemen1PortIds(portIds) {
      return _networkPairing2.default.findAll({
        where: {
          'elemen1PortId': {
            $in: portIds
          }
        }
      });
    }
  }, {
    key: 'findNetworkPairingElemenId1ByUuids',
    value: function findNetworkPairingElemenId1ByUuids(uuids) {
      var query = 'select distinct(elementId1) from network_pairing where networkElementId2 in (:uuids)';
      return _sequelize2.default.query(query, {
        replacements: {
          uuids: uuids
        },
        type: _sequelize2.default.QueryTypes.SELECT
      });
    }
  }, {
    key: 'findNetworkPairingElemenId2ByUuids',
    value: function findNetworkPairingElemenId2ByUuids(uuids) {
      var query = 'select distinct(elementId2) from network_pairing where networkElementId1 in (:uuids)';
      return _sequelize2.default.query(query, {
        replacements: {
          uuids: uuids
        },
        type: _sequelize2.default.QueryTypes.SELECT
      });
    }
  }, {
    key: 'findByFogAndElement',
    value: function findByFogAndElement(fogInstanceId1, fogInstanceId2, elementId1, elementId2) {
      return _networkPairing2.default.findOne({
        where: {
          'instanceId1': fogInstanceId1,
          'instanceId2': fogInstanceId2,
          'elementId1': elementId1,
          'elementId2': elementId2
        }
      });
    }
  }, {
    key: 'findByElementIds',
    value: function findByElementIds(elementId) {
      return _networkPairing2.default.findAll({
        where: {
          $or: [{
            elementId1: elementId
          }, {
            elementId2: elementId
          }]
        }
      });
    }
  }, {
    key: 'deleteByElementId1',
    value: function deleteByElementId1(elementId) {
      return _networkPairing2.default.destroy({
        where: {
          elementId1: elementId
        }
      });
    }
  }, {
    key: 'deleteByElementId',
    value: function deleteByElementId(elementId) {
      return _networkPairing2.default.destroy({
        where: {
          $or: [{
            elementId1: {
              $eq: elementId
            }
          }, {
            elementId2: {
              $eq: elementId
            }
          }]
        }
      });
    }
  }]);

  return NetworkPairingManager;
}(_baseManager2.default);

var instance = new NetworkPairingManager();
exports.default = instance;