'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _proxy = require('./../models/proxy');

var _proxy2 = _interopRequireDefault(_proxy);

var _changeTracking = require('./../models/changeTracking');

var _changeTracking2 = _interopRequireDefault(_changeTracking);

var _baseManager = require('./../managers/baseManager');

var _baseManager2 = _interopRequireDefault(_baseManager);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @file proxyManager.js
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @author epankov
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @description This file includes the CURD operations for the proxy Model.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

var ProxyManager = function (_BaseManager) {
    _inherits(ProxyManager, _BaseManager);

    function ProxyManager() {
        _classCallCheck(this, ProxyManager);

        return _possibleConstructorReturn(this, (ProxyManager.__proto__ || Object.getPrototypeOf(ProxyManager)).apply(this, arguments));
    }

    _createClass(ProxyManager, [{
        key: 'getEntity',
        value: function getEntity() {
            return _proxy2.default;
        }

        /**
         * @desc - finds the proxy based on the instanceId
         * @param String - instanceId
         * @return JSON - returns a JSON object of changeTracking
         */

    }, {
        key: 'findByInstanceId',
        value: function findByInstanceId(instanceId) {
            return _proxy2.default.find({
                where: {
                    iofog_uuid: instanceId
                }
            });
        }

        /**
         * @desc - deletes the proxy based on the instanceId
         * @param String - instanceId
         * @return  Integer - returns the number of rows deleted
         */

    }, {
        key: 'deleteByInstanceId',
        value: function deleteByInstanceId(instanceId) {
            return _proxy2.default.destroy({
                where: {
                    iofog_uuid: instanceId
                }
            });
        }

        /**
         * @desc - updates the proxy data
         * @param Integer, JSON object - uuid, data
         * @return Integer - returns the number of rows updated
         */

    }, {
        key: 'updateByUuid',
        value: function updateByUuid(uuid, data) {
            return _proxy2.default.update(data, {
                where: {
                    iofog_uuid: uuid
                }
            });
        }
    }]);

    return ProxyManager;
}(_baseManager2.default);

var instance = new ProxyManager();
exports.default = instance;