'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _satellitePort = require('./../models/satellitePort');

var _satellitePort2 = _interopRequireDefault(_satellitePort);

var _baseManager = require('./../managers/baseManager');

var _baseManager2 = _interopRequireDefault(_baseManager);

var _sequelize = require('./../utils/sequelize');

var _sequelize2 = _interopRequireDefault(_sequelize);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @file satellitePortManager.js
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @author Zishan Iqbal
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @description
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

var SatellitePortManager = function (_BaseManager) {
  _inherits(SatellitePortManager, _BaseManager);

  function SatellitePortManager() {
    _classCallCheck(this, SatellitePortManager);

    return _possibleConstructorReturn(this, (SatellitePortManager.__proto__ || Object.getPrototypeOf(SatellitePortManager)).apply(this, arguments));
  }

  _createClass(SatellitePortManager, [{
    key: 'getEntity',
    value: function getEntity() {
      return _satellitePort2.default;
    }
  }, {
    key: 'getMaxPort',
    value: function getMaxPort() {
      return _satellitePort2.default.max('port2');
    }
  }, {
    key: 'findAllBySatelliteId',
    value: function findAllBySatelliteId(satelliteId) {
      return _satellitePort2.default.findAll({
        where: {
          satellite_id: satelliteId
        }
      });
    }
  }, {
    key: 'deleteByPortId',
    value: function deleteByPortId(satellitePortId) {
      return _satellitePort2.default.destroy({
        where: {
          id: satellitePortId
        }
      });
    }
  }, {
    key: 'findBySatellitePortIds',
    value: function findBySatellitePortIds(networkPairingIds) {
      return _satellitePort2.default.findAll({
        where: {
          id: {
            $in: networkPairingIds
          }
        }
      });
    }
  }, {
    key: 'getPortPasscodeForNetworkElements',
    value: function getPortPasscodeForNetworkElements(elementId) {
      var query = ' \
      SELECT sp.passcode_port1, sp.mapping_id, s.domain \
      FROM satellite_port sp, satellite s \
      WHERE sp.id IN ( \
        SELECT satellitePortId \
        FROM network_pairing \
        WHERE elementID1 = "' + elementId + '" \
        OR elementID2 = "' + elementId + '" \
      ) \
      AND sp.satellite_id = s.id';

      return _sequelize2.default.query(query);
    }
  }, {
    key: 'deletePortsForNetworkElements',
    value: function deletePortsForNetworkElements(elementId) {
      var deleteQuery = ' \
      DELETE FROM satellite_port \
      WHERE id IN ( \
        SELECT satellitePortId \
        FROM network_pairing \
        WHERE elementID1 = "' + elementId + '" \
        OR elementID2 = "' + elementId + '" \
      )';

      return _sequelize2.default.query(deleteQuery);
    }
  }]);

  return SatellitePortManager;
}(_baseManager2.default);

var instance = new SatellitePortManager();
exports.default = instance;