'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _sequelize = require('sequelize');

var _sequelize2 = _interopRequireDefault(_sequelize);

var _sequelize3 = require('./../utils/sequelize');

var _sequelize4 = _interopRequireDefault(_sequelize3);

var _fog = require('./fog');

var _fog2 = _interopRequireDefault(_fog);

var _registry = require('./registry');

var _registry2 = _interopRequireDefault(_registry);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @file changeTracking.js
 * @author Zishan Iqbal
 * @description This file includes a iofog_change_tracking model used by sequalize for ORM;
 */

var ChangeTracking = _sequelize4.default.define('iofog_change_tracking', {
  id: {
    type: _sequelize2.default.INTEGER,
    primaryKey: true,
    autoIncrement: true,
    field: 'ID'
  },
  containerConfig: {
    type: _sequelize2.default.BIGINT,
    field: 'container_config'
  },
  reboot: {
    type: _sequelize2.default.BOOLEAN,
    field: 'reboot'
  },
  version: {
    type: _sequelize2.default.BIGINT,
    field: 'version'
  },
  containerList: {
    type: _sequelize2.default.BIGINT,
    field: 'container_list'
  },
  config: {
    type: _sequelize2.default.BIGINT,
    field: 'config'
  },
  routing: {
    type: _sequelize2.default.BIGINT,
    field: 'routing'
  },
  registries: {
    type: _sequelize2.default.BIGINT,
    field: 'registries'
  },
  proxy: {
    type: _sequelize2.default.BIGINT,
    field: 'proxy'
  },
  diagnostics: {
    type: _sequelize2.default.BIGINT,
    field: 'diagnostics'
  }
}, {
  // don't add the timestamp attributes (updatedAt, createdAt)
  timestamps: false,
  // disable the modification of table names
  freezeTableName: true,
  // don't use camelcase for automatically added attributes but underscore style
  // so updatedAt will be updated_at
  underscored: true
});

ChangeTracking.belongsTo(_fog2.default, {
  foreignKey: 'iofog_uuid'
});
exports.default = ChangeTracking;