'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _sequelize = require('sequelize');

var _sequelize2 = _interopRequireDefault(_sequelize);

var _sequelize3 = require('./../utils/sequelize');

var _sequelize4 = _interopRequireDefault(_sequelize3);

var _fog = require('./fog');

var _fog2 = _interopRequireDefault(_fog);

var _elementInstance = require('./elementInstance');

var _elementInstance2 = _interopRequireDefault(_elementInstance);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @file consoles.js
 * @author Zishan Iqbal
 * @description This file includes a consoles model used by sequalize for ORM;
 */

var Console = _sequelize4.default.define('consoles', {
  id: {
    type: _sequelize2.default.INTEGER,
    primaryKey: true,
    autoIncrement: true,
    field: 'ID'
  },
  version: {
    type: _sequelize2.default.BIGINT,
    field: 'version'
  },
  apiBaseUrl: {
    type: _sequelize2.default.TEXT,
    field: 'api_base_url'
  },
  accessToken: {
    type: _sequelize2.default.TEXT,
    field: 'access_token'
  }
}, {
  // don't add the timestamp attributes (updatedAt, createdAt)
  timestamps: false,
  // disable the modification of table names
  freezeTableName: true,
  // don't use camelcase for automatically added attributes but underscore style
  // so updatedAt will be updated_at
  underscored: true
});

Console.belongsTo(_fog2.default);
Console.belongsTo(_elementInstance2.default, {
  foreignKey: 'ElementId',
  as: 'elementId',
  targetKey: 'uuid'
});

exports.default = Console;