'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _sequelize = require('sequelize');

var _sequelize2 = _interopRequireDefault(_sequelize);

var _sequelize3 = require('./../utils/sequelize');

var _sequelize4 = _interopRequireDefault(_sequelize3);

var _user = require('./user');

var _user2 = _interopRequireDefault(_user);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DataTracks = _sequelize4.default.define('data_tracks', {
  id: {
    type: _sequelize2.default.INTEGER,
    primaryKey: true,
    autoIncrement: true,
    field: 'ID'
  },
  name: {
    type: _sequelize2.default.TEXT,
    field: 'name'
  },
  instanceId: {
    type: _sequelize2.default.TEXT,
    field: 'instance_id'
  },
  updatedBy: {
    type: _sequelize2.default.BIGINT,
    field: 'updated_by'
  },
  description: {
    type: _sequelize2.default.TEXT,
    field: 'description'
  },
  isSelected: {
    type: _sequelize2.default.INTEGER,
    field: 'is_selected'
  },
  isActivated: {
    type: _sequelize2.default.INTEGER,
    field: 'is_activated'
  }
}, {
  // don't add the timestamp attributes (updatedAt, createdAt)
  timestamps: true,
  // disable the modification of table names
  freezeTableName: true,
  // don't use camelcase for automatically added attributes but underscore style
  // so updatedAt will be updated_at
  underscored: true
}); /**
     * @file dataTracks.js
     * @author Zishan Iqbal
     * @description This file includes a data_tracks model used by sequalize for ORM;
     */

DataTracks.belongsTo(_user2.default);

exports.default = DataTracks;