'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _sequelize = require('sequelize');

var _sequelize2 = _interopRequireDefault(_sequelize);

var _sequelize3 = require('./../utils/sequelize');

var _sequelize4 = _interopRequireDefault(_sequelize3);

var _element = require('./element');

var _element2 = _interopRequireDefault(_element);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ElementAdvertisedPort = _sequelize4.default.define('element_advertised_port', {
  id: {
    type: _sequelize2.default.INTEGER,
    primaryKey: true,
    autoIncrement: true,
    field: 'ID'
  },
  portNumber: {
    type: _sequelize2.default.BIGINT,
    field: 'port_number'
  },
  name: {
    type: _sequelize2.default.TEXT,
    field: 'name'
  },
  description: {
    type: _sequelize2.default.TEXT,
    field: 'description'
  }
}, {
  // don't add the timestamp attributes (updatedAt, createdAt)
  timestamps: false,
  // disable the modification of table names
  freezeTableName: true,
  // don't use camelcase for automatically added attributes but underscore style
  // so updatedAt will be updated_at
  underscored: true
}); /**
     * @file ElementAdvertisedPort.js
     * @author Zishan Iqbal
     * @description This file includes a element_advertised_port model used by sequalize for ORM;
     */

ElementAdvertisedPort.belongsTo(_element2.default);

exports.default = ElementAdvertisedPort;