'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _sequelize = require('sequelize');

var _sequelize2 = _interopRequireDefault(_sequelize);

var _sequelize3 = require('./../utils/sequelize');

var _sequelize4 = _interopRequireDefault(_sequelize3);

var _element = require('./element');

var _element2 = _interopRequireDefault(_element);

var _fogType = require('./fogType');

var _fogType2 = _interopRequireDefault(_fogType);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @file ioElementImage.js
 * @author Zishan Iqbal
 * @description This file includes a IOElementImage model used by sequalize for ORM;
 */

var ElementImage = _sequelize4.default.define('element_images', {
  id: {
    type: _sequelize2.default.INTEGER,
    primaryKey: true,
    autoIncrement: true,
    field: 'ID'
  },
  containerImage: {
    type: _sequelize2.default.TEXT,
    field: 'container_image'
  }
}, {
  // don't add the timestamp attributes (updatedAt, createdAt)
  timestamps: false,
  // disable the modification of table names
  freezeTableName: true,
  // don't use camelcase for automatically added attributes but underscore style
  // so updatedAt will be updated_at
  underscored: true
});

ElementImage.belongsTo(_element2.default, {
  foreignKey: 'element_id'
});
ElementImage.belongsTo(_fogType2.default, {
  foreignKey: 'iofog_type_id'
});

exports.default = ElementImage;