'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _sequelize = require('sequelize');

var _sequelize2 = _interopRequireDefault(_sequelize);

var _sequelize3 = require('./../utils/sequelize');

var _sequelize4 = _interopRequireDefault(_sequelize3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @file elementinstancePort.js
 * @author Zishan Iqbal
 * @description This file includes a element_instance_connections model used by sequalize for ORM;
 */

var ElementInstanceConnections = _sequelize4.default.define('element_instance_connections', {
  id: {
    type: _sequelize2.default.INTEGER,
    primaryKey: true,
    autoIncrement: true,
    field: 'ID'
  },
  sourceElementInstance: {
    type: _sequelize2.default.BIGINT,
    field: 'source_element_instance'
  },
  destinationElementInstance: {
    type: _sequelize2.default.BIGINT,
    field: 'destination_element_instance'
  }
}, {
  // don't add the timestamp attributes (updatedAt, createdAt)
  timestamps: false,
  // disable the modification of table names
  freezeTableName: true,
  // don't use camelcase for automatically added attributes but underscore style
  // so updatedAt will be updated_at
  underscored: true
});

exports.default = ElementInstanceConnections;