'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _sequelize = require('sequelize');

var _sequelize2 = _interopRequireDefault(_sequelize);

var _sequelize3 = require('./../utils/sequelize');

var _sequelize4 = _interopRequireDefault(_sequelize3);

var _elementInstance = require('./elementInstance');

var _elementInstance2 = _interopRequireDefault(_elementInstance);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ElementInstancePort = _sequelize4.default.define('element_instance_port', {
  id: {
    type: _sequelize2.default.INTEGER,
    primaryKey: true,
    autoIncrement: true,
    field: 'ID'
  },
  portinternal: {
    type: _sequelize2.default.BIGINT,
    field: 'port_internal'
  },
  portexternal: {
    type: _sequelize2.default.BIGINT,
    field: 'port_external'
  },
  updatedBy: {
    type: _sequelize2.default.BIGINT,
    field: 'updated_by'
  }
}, {
  // don't add the timestamp attributes (updatedAt, createdAt)
  timestamps: true,
  // disable the modification of table names
  freezeTableName: true,
  // don't use camelcase for automatically added attributes but underscore style
  // so updatedAt will be updated_at
  underscored: true
}); /**
     * @file elementinstancePort.js
     * @author Zishan Iqbal
     * @description This file includes a element_instance_port model used by sequalize for ORM;
     */

ElementInstancePort.belongsTo(_elementInstance2.default, {
  foreignKey: 'elementId',
  as: 'ElementId',
  targetKey: 'uuid'
});

exports.default = ElementInstancePort;