'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _sequelize = require('sequelize');

var _sequelize2 = _interopRequireDefault(_sequelize);

var _sequelize3 = require('./../utils/sequelize');

var _sequelize4 = _interopRequireDefault(_sequelize3);

var _elementInstance = require('./elementInstance');

var _elementInstance2 = _interopRequireDefault(_elementInstance);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ElementInstanceStatus = _sequelize4.default.define('element_instance_status', {
    id: {
        type: _sequelize2.default.INTEGER,
        primaryKey: true,
        autoIncrement: true,
        field: 'ID'
    },
    status: {
        type: _sequelize2.default.TEXT,
        field: 'status'
    },
    cpuUsage: {
        type: _sequelize2.default.FLOAT,
        defaultValue: 0.000,
        field: 'cpu_usage'
    },
    memoryUsage: {
        type: _sequelize2.default.BIGINT,
        defaultValue: 0,
        field: 'memory_usage'
    },
    containerId: {
        type: _sequelize2.default.BIGINT,
        field: 'container_id'
    }
}, {
    // add the timestamp attributes (updatedAt, createdAt)
    timestamps: true,
    // disable the modification of table names
    freezeTableName: true,
    // don't use camelcase for automatically added attributes but underscore style
    // so updatedAt will be updated_at
    underscored: true
}); /**
     * @author elukashick
     */

ElementInstanceStatus.belongsTo(_elementInstance2.default, {
    foreignKey: 'element_instance_uuid'
});
exports.default = ElementInstanceStatus;