'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _sequelize = require('sequelize');

var _sequelize2 = _interopRequireDefault(_sequelize);

var _sequelize3 = require('./../utils/sequelize');

var _sequelize4 = _interopRequireDefault(_sequelize3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @author elukashick
 */

var ElementInstanceToCleanUp = _sequelize4.default.define('element_instance_clean_up', {
    id: {
        type: _sequelize2.default.INTEGER,
        primaryKey: true,
        autoIncrement: true,
        field: 'ID'
    },
    elementInstanceUUID: {
        type: _sequelize2.default.BIGINT,
        defaultValue: 0,
        field: 'element_instance_uuid'
    },
    iofogUUID: {
        type: _sequelize2.default.BIGINT,
        defaultValue: 0,
        field: 'iofog_uuid'
    }
}, {
    // add the timestamp attributes (updatedAt, createdAt)
    timestamps: true,
    // disable the modification of table names
    freezeTableName: true,
    // don't use camelcase for automatically added attributes but underscore style
    // so updatedAt will be updated_at
    underscored: true
});

exports.default = ElementInstanceToCleanUp;