'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _sequelize = require('sequelize');

var _sequelize2 = _interopRequireDefault(_sequelize);

var _sequelize3 = require('./../utils/sequelize');

var _sequelize4 = _interopRequireDefault(_sequelize3);

var _element = require('./element');

var _element2 = _interopRequireDefault(_element);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ElementOutputType = _sequelize4.default.define('element_output_type', {
  id: {
    type: _sequelize2.default.INTEGER,
    primaryKey: true,
    autoIncrement: true,
    field: 'ID'
  },
  elementKey: {
    type: _sequelize2.default.BIGINT,
    field: 'element_key'
  },
  infoType: {
    type: _sequelize2.default.TEXT,
    field: 'info_type'
  },
  infoFormat: {
    type: _sequelize2.default.TEXT,
    field: 'info_format'
  }

}, {
  // don't add the timestamp attributes (updatedAt, createdAt)
  timestamps: false,
  // disable the modification of table names
  freezeTableName: true,
  // don't use camelcase for automatically added attributes but underscore style
  // so updatedAt will be updated_at
  underscored: true
}); /**
     * @file element.js
     * @author Zishan Iqbal
     * @description This file includes a element_output_type model used by sequalize for ORM;
     */

ElementOutputType.belongsTo(_element2.default);

exports.default = ElementOutputType;