'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _sequelize = require('sequelize');

var _sequelize2 = _interopRequireDefault(_sequelize);

var _sequelize3 = require('./../utils/sequelize');

var _sequelize4 = _interopRequireDefault(_sequelize3);

var _user = require('./user');

var _user2 = _interopRequireDefault(_user);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var EmailActivationCode = _sequelize4.default.define('email_activation_code', {
  id: { type: _sequelize2.default.INTEGER, primaryKey: true, autoIncrement: true, field: 'ID' },
  activationCode: { type: _sequelize2.default.TEXT, field: 'activation_code' },
  expirationTime: { type: _sequelize2.default.BIGINT, field: 'expiration_time' }
}, {
  // don't add the timestamp attributes (updatedAt, createdAt)
  timestamps: false,
  // disable the modification of table names
  freezeTableName: true,
  // don't use camelcase for automatically added attributes but underscore style
  // so updatedAt will be updated_at
  underscored: true
}); /**
    * @file emailActivationCodes.js
    * @author Zishan Iqbal
    * @description This file includes a email_activation_codes model used by sequalize for ORM;
    */

_user2.default.hasMany(EmailActivationCode, { foreignKey: 'user_id' });

exports.default = EmailActivationCode;