'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _sequelize = require('sequelize');

var _sequelize2 = _interopRequireDefault(_sequelize);

var _sequelize3 = require('./../utils/sequelize');

var _sequelize4 = _interopRequireDefault(_sequelize3);

var _fog = require('./fog');

var _fog2 = _interopRequireDefault(_fog);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FogAccessToken = _sequelize4.default.define('iofog_access_tokens', {
  id: { type: _sequelize2.default.INTEGER, primaryKey: true, autoIncrement: true, field: 'ID' },
  userId: { type: _sequelize2.default.INTEGER, field: 'user_id' },
  expirationTime: { type: _sequelize2.default.BIGINT, field: 'expiration_time' },
  token: { type: _sequelize2.default.TEXT, field: 'token' }
}, {
  // don't add the timestamp attributes (updatedAt, createdAt)
  timestamps: false,
  // disable the modification of table names
  freezeTableName: true,
  // don't use camelcase for automatically added attributes but underscore style
  // so updatedAt will be updated_at
  underscored: true
}); /**
    * @file fogAccessToken.js
    * @author Zishan Iqbal
    * @description This file includes a iofog_access_tokens model used by sequalize for ORM;
    */

FogAccessToken.belongsTo(_fog2.default, {
  foreignKey: 'iofog_uuid'
});

exports.default = FogAccessToken;