'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _sequelize = require('sequelize');

var _sequelize2 = _interopRequireDefault(_sequelize);

var _sequelize3 = require('./../utils/sequelize');

var _sequelize4 = _interopRequireDefault(_sequelize3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
* @file fogProvisionKey.js
* @author Zishan Iqbal
* @description This file includes a iofog_provision_keys model used by sequalize for ORM;
*/

var FogProvisionKey = _sequelize4.default.define('iofog_provision_keys', {
  id: { type: _sequelize2.default.INTEGER, primaryKey: true, autoIncrement: true, field: 'ID' },
  provisionKey: { type: _sequelize2.default.STRING(100), field: 'provisioning_string' },
  expirationTime: { type: _sequelize2.default.BIGINT, field: 'expiration_time'
    // instanceId: {type: Sequelize.TEXT, field: 'instanceID'}
  } }, {
  // don't add the timestamp attributes (updatedAt, createdAt)
  timestamps: false,
  // disable the modification of table names
  freezeTableName: true,
  // don't use camelcase for automatically added attributes but underscore style
  // so updatedAt will be updated_at
  underscored: true
});

exports.default = FogProvisionKey;