'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _sequelize = require('sequelize');

var _sequelize2 = _interopRequireDefault(_sequelize);

var _sequelize3 = require('./../utils/sequelize');

var _sequelize4 = _interopRequireDefault(_sequelize3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
* @file fogSystemAccessToken.js
* @author Zishan Iqbal
* @description This file includes a system_access_tokens model used by sequalize for ORM;
*/

var FogSystemAccessToken = _sequelize4.default.define('system_access_tokens', {
  id: { type: _sequelize2.default.INTEGER, primaryKey: true, autoIncrement: true, field: 'ID' },
  userId: { type: _sequelize2.default.INTEGER, field: 'User_ID' },
  expirationTime: { type: _sequelize2.default.DATE, field: 'Expiration_Time' },
  token: { type: _sequelize2.default.TEXT, field: 'Token' }
}, {
  // don't add the timestamp attributes (updatedAt, createdAt)
  timestamps: false,
  // disable the modification of table names
  freezeTableName: true,
  // don't use camelcase for automatically added attributes but underscore style
  // so updatedAt will be updated_at
  underscored: true
});

exports.default = FogSystemAccessToken;