'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _sequelize = require('sequelize');

var _sequelize2 = _interopRequireDefault(_sequelize);

var _sequelize3 = require('./../utils/sequelize');

var _sequelize4 = _interopRequireDefault(_sequelize3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
* @file fogType.js
* @author Zishan Iqbal
* @description This file includes a fog_type model used by sequalize for ORM;
*/

var FogType = _sequelize4.default.define('iofog_type', {
  id: { type: _sequelize2.default.INTEGER, primaryKey: true, autoIncrement: true, field: 'ID' },
  name: { type: _sequelize2.default.TEXT, field: 'Name' },
  image: { type: _sequelize2.default.TEXT, field: 'Image' },
  description: { type: _sequelize2.default.TEXT, field: 'Description' },
  streamViewerElementKey: { type: _sequelize2.default.BIGINT, field: 'StreamViewerElementKey' },
  consoleElementKey: { type: _sequelize2.default.BIGINT, field: 'consoleElementKey' },
  networkElementKey: { type: _sequelize2.default.BIGINT, field: 'NetworkElementKey' },
  halElementKey: { type: _sequelize2.default.BIGINT, field: 'HalElementKey' },
  mongoElementKey: { type: _sequelize2.default.BIGINT, field: 'MongoElementKey' },
  influxElementKey: { type: _sequelize2.default.BIGINT, field: 'InfluxElementKey' },
  grafanaElementKey: { type: _sequelize2.default.BIGINT, field: 'GrafanaElementKey' },
  bluetoothElementKey: { type: _sequelize2.default.BIGINT, field: 'BluetoothElementKey' }
}, {
  // don't add the timestamp attributes (updatedAt, createdAt)
  timestamps: false,
  // disable the modification of table names
  freezeTableName: true,
  // don't use camelcase for automatically added attributes but underscore style
  // so updatedAt will be updated_at
  underscored: true
});

exports.default = FogType;