'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _sequelize = require('sequelize');

var _sequelize2 = _interopRequireDefault(_sequelize);

var _sequelize3 = require('./../utils/sequelize');

var _sequelize4 = _interopRequireDefault(_sequelize3);

var _user = require('./user');

var _user2 = _interopRequireDefault(_user);

var _fog = require('./fog');

var _fog2 = _interopRequireDefault(_fog);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
* @file fogUser.js
* @author Zishan Iqbal
* @description This file includes a iofog_users model used by sequalize for ORM;
*/

var FogUser = _sequelize4.default.define('iofog_users', {
  id: { type: _sequelize2.default.INTEGER, primaryKey: true, autoIncrement: true, field: 'ID' }
}, {
  // don't add the timestamp attributes (updatedAt, createdAt)
  timestamps: false,
  // disable the modification of table names
  freezeTableName: true,
  // don't use camelcase for automatically added attributes but underscore style
  // so updatedAt will be updated_at
  underscored: true
});

_user2.default.belongsToMany(_fog2.default, { through: FogUser, as: 'userId', foreignKey: 'user_id' });
_fog2.default.belongsToMany(_user2.default, { through: FogUser, as: 'fogId', foreignKey: 'fog_id' });

exports.default = FogUser;