'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _sequelize = require('sequelize');

var _sequelize2 = _interopRequireDefault(_sequelize);

var _sequelize3 = require('./../utils/sequelize');

var _sequelize4 = _interopRequireDefault(_sequelize3);

var _fog = require('./fog');

var _fog2 = _interopRequireDefault(_fog);

var _fogProvisionKey = require('./fogProvisionKey');

var _fogProvisionKey2 = _interopRequireDefault(_fogProvisionKey);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @file fogVersionCommand.js
 * @author Maksim Chepelev
 * @description This file includes a iofog_version_commands model used by sequalize for ORM;
 */

var FogVersionCommand = _sequelize4.default.define('iofog_version_commands', {
    id: { type: _sequelize2.default.INTEGER, primaryKey: true, autoIncrement: true, field: 'ID' },
    versionCommand: { type: _sequelize2.default.STRING(100), field: 'version_command' }
}, {
    // don't add the timestamp attributes (updatedAt, createdAt)
    timestamps: false,
    // disable the modification of table names
    freezeTableName: true,
    // don't use camelcase for automatically added attributes but underscore style
    // so updatedAt will be updated_at
    underscored: true
});

FogVersionCommand.belongsTo(_fog2.default, {
    foreignKey: 'iofog_uuid'
});

exports.default = FogVersionCommand;