'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _sequelize = require('sequelize');

var _sequelize2 = _interopRequireDefault(_sequelize);

var _sequelize3 = require('./../utils/sequelize');

var _sequelize4 = _interopRequireDefault(_sequelize3);

var _elementInstance = require('./elementInstance');

var _elementInstance2 = _interopRequireDefault(_elementInstance);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var InstanceTrack = _sequelize4.default.define('instance_track', {
  id: { type: _sequelize2.default.INTEGER, primaryKey: true, autoIncrement: true, field: 'ID' },
  name: { type: _sequelize2.default.TEXT, field: 'name' },
  description: { type: _sequelize2.default.TEXT, field: 'description' },
  lastUpdated: { type: _sequelize2.default.DATE, field: 'last_updated' },
  isSelected: { type: _sequelize2.default.BOOLEAN, field: 'is_selected' },
  isActivated: { type: _sequelize2.default.BOOLEAN, field: 'is_activated' },
  updatedBy: { type: _sequelize2.default.BIGINT, field: 'updated_by' }
}, {
  // don't add the timestamp attributes (updatedAt, createdAt)
  timestamps: true,
  // disable the modification of table names
  freezeTableName: true,
  // don't use camelcase for automatically added attributes but underscore style
  // so updatedAt will be updated_at
  underscored: true
}); /**
    * @file instanceTrack.js
    * @author Zishan Iqbal
    * @description This file includes a instance_track model used by sequalize for ORM;
    */

InstanceTrack.belongsTo(_elementInstance2.default);

exports.default = InstanceTrack;