'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _sequelize = require('sequelize');

var _sequelize2 = _interopRequireDefault(_sequelize);

var _sequelize3 = require('./../utils/sequelize');

var _sequelize4 = _interopRequireDefault(_sequelize3);

var _fog = require('./fog');

var _fog2 = _interopRequireDefault(_fog);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Proxy = _sequelize4.default.define('proxy', {
    id: {
        type: _sequelize2.default.INTEGER,
        primaryKey: true,
        autoIncrement: true,
        field: 'ID'
    },
    username: {
        type: _sequelize2.default.TEXT,
        field: 'username'
    },
    password: {
        type: _sequelize2.default.TEXT,
        field: 'password'
    },
    host: {
        type: _sequelize2.default.TEXT,
        field: 'host'
    },
    rport: {
        type: _sequelize2.default.INTEGER,
        field: 'remote_port'
    },
    lport: {
        type: _sequelize2.default.INTEGER,
        defaultValue: 22,
        field: 'local_port'
    },
    rsakey: {
        type: _sequelize2.default.TEXT,
        field: 'rsa_key'
    },
    close: {
        type: _sequelize2.default.BOOLEAN,
        defaultValue: false,
        field: 'close'
    }
}, {
    // don't add the timestamp attributes (updatedAt, createdAt)
    timestamps: false,
    // disable the modification of table names
    freezeTableName: true,
    // don't use camelcase for automatically added attributes but underscore style
    // so updatedAt will be updated_at
    underscored: true
}); /**
     * @file proxy.js
     * @author epankov
     * @description This file includes a proxy model used by sequalize for ORM;
     */

Proxy.belongsTo(_fog2.default, {
    foreignKey: 'iofog_uuid'
});

exports.default = Proxy;