'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _sequelize = require('sequelize');

var _sequelize2 = _interopRequireDefault(_sequelize);

var _sequelize3 = require('./../utils/sequelize');

var _sequelize4 = _interopRequireDefault(_sequelize3);

var _user = require('./user');

var _user2 = _interopRequireDefault(_user);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Registry = _sequelize4.default.define('registry', {
  id: { type: _sequelize2.default.INTEGER, primaryKey: true, autoIncrement: true, field: 'ID' },
  url: { type: _sequelize2.default.TEXT, field: 'url' },
  ispublic: { type: _sequelize2.default.BOOLEAN, field: 'is_public' },
  secure: { type: _sequelize2.default.BOOLEAN, field: 'secure' },
  certificate: { type: _sequelize2.default.TEXT, field: 'certificate' },
  requirescert: { type: _sequelize2.default.BOOLEAN, field: 'requires_cert' },
  username: { type: _sequelize2.default.TEXT, field: 'user_name' },
  password: { type: _sequelize2.default.TEXT, field: 'password' },
  useremail: { type: _sequelize2.default.BIGINT, field: 'user_email' },
  user_id: { type: _sequelize2.default.INTEGER, field: 'user_id' }
}, {
  // don't add the timestamp attributes (updatedAt, createdAt)
  timestamps: false,
  // disable the modification of table names
  freezeTableName: true,
  // don't use camelcase for automatically added attributes but underscore style
  // so updatedAt will be updated_at
  underscored: true
}); /**
    * @file registry.js
    * @author Zishan Iqbal
    * @description This file includes a registry model used by sequalize for ORM;
    */


Registry.belongsTo(_user2.default, {
  foreignKey: 'user_id'
});

exports.default = Registry;