'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _sequelize = require('sequelize');

var _sequelize2 = _interopRequireDefault(_sequelize);

var _sequelize3 = require('./../utils/sequelize');

var _sequelize4 = _interopRequireDefault(_sequelize3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @file satellitejs
 * @author Zishan Iqbal
 * @description
 */

var Satellite = _sequelize4.default.define('satellite', {
  id: {
    type: _sequelize2.default.INTEGER,
    primaryKey: true,
    autoIncrement: true,
    field: 'ID'
  },
  name: {
    type: _sequelize2.default.TEXT,
    field: 'name'
  },
  domain: {
    type: _sequelize2.default.TEXT,
    field: 'domain'
  },
  publicIP: {
    type: _sequelize2.default.TEXT,
    field: 'public_ip'
  },
  cert: {
    type: _sequelize2.default.TEXT,
    field: 'cert'
  }
}, {
  // don't add the timestamp attributes (updatedAt, createdAt)
  timestamps: true,
  // disable the modification of table names
  freezeTableName: true,
  // don't use camelcase for automatically added attributes but underscore style
  // so updatedAt will be updated_at
  underscored: true
});

exports.default = Satellite;