'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _sequelize = require('sequelize');

var _sequelize2 = _interopRequireDefault(_sequelize);

var _sequelize3 = require('./../utils/sequelize');

var _sequelize4 = _interopRequireDefault(_sequelize3);

var _satellite = require('./satellite');

var _satellite2 = _interopRequireDefault(_satellite);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SatellitePort = _sequelize4.default.define('satellite_port', {
  id: {
    type: _sequelize2.default.INTEGER,
    primaryKey: true,
    autoIncrement: true,
    field: 'ID'
  },
  port1: {
    type: _sequelize2.default.BIGINT,
    field: 'port1'
  },
  port2: {
    type: _sequelize2.default.BIGINT,
    field: 'port2'
  },
  maxConnectionsPort1: {
    type: _sequelize2.default.BIGINT,
    field: 'max_connections_port1'
  },
  maxConnectionsPort2: {
    type: _sequelize2.default.BIGINT,
    field: 'max_connection_port2'
  },
  passcodePort1: {
    type: _sequelize2.default.TEXT,
    field: 'passcode_port1'
  },
  passcodePort2: {
    type: _sequelize2.default.TEXT,
    field: 'passcode_port2'
  },
  heartBeatAbsenceThresholdPort1: {
    type: _sequelize2.default.BIGINT,
    field: 'heartbeat_absence_threshold_port1'
  },
  heartBeatAbsenceThresholdPort2: {
    type: _sequelize2.default.BIGINT,
    field: 'heartbeat_absence_threshold_port2'
  },
  mappingId: {
    type: _sequelize2.default.TEXT,
    field: 'mapping_id'
  },
  updatedBy: {
    type: _sequelize2.default.BIGINT,
    field: 'updated_by'
  }
}, {
  // don't add the timestamp attributes (updatedAt, createdAt)
  timestamps: true,
  // disable the modification of table names
  freezeTableName: true,
  // don't use camelcase for automatically added attributes but underscore style
  // so updatedAt will be updated_at
  underscored: true
}); /**
     * @file satellitePort.js
     * @author Zishan Iqbal
     * @description
     */

SatellitePort.belongsTo(_satellite2.default);

exports.default = SatellitePort;