"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _sequelize = require("sequelize");

var _sequelize2 = _interopRequireDefault(_sequelize);

var _elementInstance = require("./elementInstance");

var _elementInstance2 = _interopRequireDefault(_elementInstance);

var _sequelize3 = require("../utils/sequelize");

var _sequelize4 = _interopRequireDefault(_sequelize3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var StraceDiagnostics = _sequelize4.default.define('strace_diagnostics', {
    id: {
        type: _sequelize2.default.INTEGER,
        primaryKey: true,
        autoIncrement: true,
        field: 'ID'
    },
    straceRun: {
        type: _sequelize2.default.BOOLEAN,
        field: 'straceRun'
    },
    buffer: {
        type: _sequelize2.default.BIGINT,
        field: 'buffer',
        defaultValue: ''
    }
}, {
    // don't add the timestamp attributes (updatedAt, createdAt)
    timestamps: false,
    // disable the modification of table names
    freezeTableName: true,
    // don't use camelcase for automatically added attributes but underscore style
    // so updatedAt will be updated_at
    underscored: true
});

StraceDiagnostics.belongsTo(_elementInstance2.default, {
    foreignKey: 'element_instance_uuid'
});
exports.default = StraceDiagnostics;