'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _sequelize = require('sequelize');

var _sequelize2 = _interopRequireDefault(_sequelize);

var _sequelize3 = require('./../utils/sequelize');

var _sequelize4 = _interopRequireDefault(_sequelize3);

var _fog = require('./fog');

var _fog2 = _interopRequireDefault(_fog);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var StreamViewer = _sequelize4.default.define('stream_viewer', {
  id: {
    type: _sequelize2.default.INTEGER,
    primaryKey: true,
    autoIncrement: true,
    field: 'ID'
  },
  version: {
    type: _sequelize2.default.BIGINT,
    field: 'version'
  },
  apiBaseUrl: {
    type: _sequelize2.default.TEXT,
    field: 'api_base_url'
  },
  accessToken: {
    type: _sequelize2.default.TEXT,
    field: 'access_token'
  },
  elementId: {
    type: _sequelize2.default.TEXT,
    field: 'element_id'
  }
}, {
  // don't add the timestamp attributes (updatedAt, createdAt)
  timestamps: false,
  // disable the modification of table names
  freezeTableName: true,
  // don't use camelcase for automatically added attributes but underscore style
  // so updatedAt will be updated_at
  underscored: true
}); /**
     * @file streamViewer.js
     * @author Zishan Iqbal
     * @description This file includes a stream_viewer model used by sequalize for ORM;
     */

StreamViewer.belongsTo(_fog2.default, {
  foreignKey: 'iofog_uuid'
});

exports.default = StreamViewer;