'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _sequelize = require('sequelize');

var _sequelize2 = _interopRequireDefault(_sequelize);

var _sequelize3 = require('./../utils/sequelize');

var _sequelize4 = _interopRequireDefault(_sequelize3);

var _fog = require('./fog');

var _fog2 = _interopRequireDefault(_fog);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var USBInfo = _sequelize4.default.define('usb_info', {

    id: {
        type: _sequelize2.default.INTEGER,
        primaryKey: true,
        autoIncrement: true,
        field: 'ID'
    },
    iofog_uuid: {
        type: _sequelize2.default.TEXT,
        field: 'iofog_uuid'
    },
    info: {
        type: _sequelize2.default.TEXT,
        defaultValue: " ",
        field: 'info'
    }
}, {
    // add the timestamp attributes (updatedAt, createdAt)
    timestamps: true,
    // disable the modification of table names
    freezeTableName: true,
    // don't use camelcase for automatically added attributes but underscore style
    // so updatedAt will be updated_at
    underscored: true
}); /**
     * @author elukashick
     * @description This file includes a usb_info model used by sequalize for ORM;
     */

USBInfo.belongsTo(_fog2.default, {
    foreignKey: 'iofog_uuid'
});

exports.default = USBInfo;