'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _sequelize = require('sequelize');

var _sequelize2 = _interopRequireDefault(_sequelize);

var _sequelize3 = require('./../utils/sequelize');

var _sequelize4 = _interopRequireDefault(_sequelize3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
* @file user.js
* @author Zishan Iqbal
* @description This file includes a users model used by sequalize for ORM;
*/

var User = _sequelize4.default.define('users', {
  id: { type: _sequelize2.default.INTEGER, primaryKey: true, autoIncrement: true, field: 'ID' },
  firstName: { type: _sequelize2.default.STRING(100), field: 'first_name' },
  lastName: { type: _sequelize2.default.STRING(100), field: 'last_name' },
  email: _sequelize2.default.STRING(100),
  password: _sequelize2.default.STRING(100),
  tempPassword: { type: _sequelize2.default.STRING(100), field: 'temp_password' },
  emailActivated: { type: _sequelize2.default.INTEGER, field: 'email_activated' },
  userAccessToken: { type: _sequelize2.default.TEXT, field: 'user_access_token' }
}, {
  // don't add the timestamp attributes (updatedAt, createdAt)
  timestamps: false,
  // disable the modification of table names
  freezeTableName: true,
  // don't use camelcase for automatically added attributes but underscore style
  // so updatedAt will be updated_at
  underscored: true
});

exports.default = User;