'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _changeTrackingManager = require('../managers/changeTrackingManager');

var _changeTrackingManager2 = _interopRequireDefault(_changeTrackingManager);

var _appUtils = require('../utils/appUtils');

var _appUtils2 = _interopRequireDefault(_appUtils);

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var createFogChangeTracking = function createFogChangeTracking(props, params, callback) {
  var fogInstanceId = _appUtils2.default.getProperty(params, props.fogInstanceId);

  _changeTrackingManager2.default.createChangeTracking(fogInstanceId).then(_appUtils2.default.onCreate.bind(null, params, props.setProperty, 'Unable to create change tracking for Fog Instance', callback));
};

var deleteChangeTracking = function deleteChangeTracking(props, params, callback) {
  var instanceId = _appUtils2.default.getProperty(params, props.instanceId);

  _changeTrackingManager2.default.deleteByInstanceId(instanceId).then(_appUtils2.default.onDeleteOptional.bind(null, params, callback));
};

var getChangeTrackingByInstanceId = function getChangeTrackingByInstanceId(props, params, callback) {
  var instanceId = _appUtils2.default.getProperty(params, props.instanceId);

  _changeTrackingManager2.default.findByInstanceId(instanceId).then(_appUtils2.default.onFindOptional.bind(null, params, props.setProperty, callback));
};

var updateChangeTracking = function updateChangeTracking(props, params, callback) {
  var fogInstanceId = _appUtils2.default.getProperty(params, props.fogInstanceId);

  _changeTrackingManager2.default.updateByUuid(fogInstanceId, props.changeObject).then(_appUtils2.default.onUpdate.bind(null, params, 'Unable to update Change Tracking', callback));
};

var updateChangeTrackingData = function updateChangeTrackingData(props, params, callback) {
  var elementInstanceData = _appUtils2.default.getProperty(params, props.elementInstanceData);

  _changeTrackingManager2.default.updateByUuid(_underscore2.default.pluck(elementInstanceData, props.field), props.changeObject).then(_appUtils2.default.onUpdate.bind(null, params, 'Unable to update Change Tracking', callback));
};

exports.default = {
  deleteChangeTracking: deleteChangeTracking,
  getChangeTrackingByInstanceId: getChangeTrackingByInstanceId,
  createFogChangeTracking: createFogChangeTracking,
  updateChangeTrackingData: updateChangeTrackingData,
  updateChangeTracking: updateChangeTracking
};