'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _consoleManager = require('../managers/consoleManager');

var _consoleManager2 = _interopRequireDefault(_consoleManager);

var _appUtils = require('../utils/appUtils');

var _appUtils2 = _interopRequireDefault(_appUtils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var createConsole = function createConsole(props, params, callback) {
  _consoleManager2.default.create(props.consoleObj).then(_appUtils2.default.onCreate.bind(null, params, null, 'Unable to create Console object', callback));
};

var getConsoleByFogInstanceId = function getConsoleByFogInstanceId(props, params, callback) {
  var instanceId = _appUtils2.default.getProperty(params, props.instanceId);

  _consoleManager2.default.findByInstanceId(instanceId).then(_appUtils2.default.onFindOptional.bind(null, params, props.setProperty, callback));
};

var deleteConsoleByFogInstanceId = function deleteConsoleByFogInstanceId(props, params, callback) {
  var instanceId = _appUtils2.default.getProperty(params, props.instanceId);

  _consoleManager2.default.deleteByInstanceId(instanceId).then(_appUtils2.default.onDeleteOptional.bind(null, params, callback));
};

exports.default = {
  createConsole: createConsole,
  getConsoleByFogInstanceId: getConsoleByFogInstanceId,
  deleteConsoleByFogInstanceId: deleteConsoleByFogInstanceId
};