"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _elementInstanceToCleanUpManager = require("../managers/elementInstanceToCleanUpManager");

var _elementInstanceToCleanUpManager2 = _interopRequireDefault(_elementInstanceToCleanUpManager);

var _appUtils = require("../utils/appUtils");

var _appUtils2 = _interopRequireDefault(_appUtils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @author elukashick
 */

var listByFogUUID = function listByFogUUID(props, params, param, callback) {
    var ioFogUUID = _appUtils2.default.getProperty(params, props.uuid);

    _elementInstanceToCleanUpManager2.default.listByFogUUID(ioFogUUID).then(function (result) {
        params.elementToCleanUpIds = [];
        if (result.length > 0) {
            for (var i = 0, len = result.length; i < len; i++) {
                params.elementToCleanUpIds.push(result[i].elementInstanceUUID);
            }
        }
        _appUtils2.default.onFindOptional(params, props.setProperty, callback);
    });
};

var deleteByElementInstanceId = function deleteByElementInstanceId(statusObj, params, callback) {
    var elementInstanceUUID = statusObj.id;

    _elementInstanceToCleanUpManager2.default.deleteByElementInstanceUUID(elementInstanceUUID).then(_appUtils2.default.onDelete.bind(null, params, null, callback));
};

var deleteByFogUUID = function deleteByFogUUID(props, params, param, callback) {
    var ioFogUUID = _appUtils2.default.getProperty(params, props.uuid);

    if (params.elementToCleanUpIds.length > 0) {
        _elementInstanceToCleanUpManager2.default.deleteByFogUUID(ioFogUUID).then(_appUtils2.default.onDelete.bind(null, params.elementToCleanUpIds, 'Unable to delete Clean Up Elements', callback));
    } else {
        callback(null, params.elementToCleanUpIds);
    }
};

exports.default = {
    listByFogUUID: listByFogUUID,
    deleteByElementInstanceId: deleteByElementInstanceId,
    deleteByFogUUID: deleteByFogUUID
};