'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _fogManager = require('../managers/fogManager');

var _fogManager2 = _interopRequireDefault(_fogManager);

var _appUtils = require('../utils/appUtils');

var _appUtils2 = _interopRequireDefault(_appUtils);

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @deprecated
 */
var createFogInstance = function createFogInstance(props, params, callback) {
  var fogType = _appUtils2.default.getProperty(params, props.fogType),
      instanceId = _appUtils2.default.generateRandomString(32),
      name = _appUtils2.default.getProperty(params, props.name),
      location = _appUtils2.default.getProperty(params, props.location),
      latitude = _appUtils2.default.getProperty(params, props.latitude),
      longitude = _appUtils2.default.getProperty(params, props.longitude),
      description = _appUtils2.default.getProperty(params, props.description);

  var config = {
    uuid: instanceId,
    name: name,
    location: location,
    latitude: latitude,
    longitude: longitude,
    description: description,
    typeKey: fogType
  };

  _fogManager2.default.createFog(config).then(_appUtils2.default.onCreate.bind(null, params, props.setProperty, 'Unable to create iofog instance', callback));
};

var createFogInstanceWithUUID = function createFogInstanceWithUUID(props, params, callback) {

  _fogManager2.default.createFog(props.fogObj).then(_appUtils2.default.onCreate.bind(null, params, props.setProperty, 'Unable to create fog instance.', callback));
};

var deleteFogInstance = function deleteFogInstance(props, params, callback) {
  var instanceId = _appUtils2.default.getProperty(params, props.instanceId);

  _fogManager2.default.deleteByInstanceId(instanceId).then(_appUtils2.default.onDelete.bind(null, params, 'Unable to delete iofog instance', callback));
};

var getFogInstance = function getFogInstance(props, params, callback) {
  var fogId = _appUtils2.default.getProperty(params, props.fogId);
  _fogManager2.default.findByInstanceId(fogId).then(function (obj) {
    if (fogId === 'NONE') {
      callback(null, params);
    } else {
      _appUtils2.default.onFind(params, props.setProperty, 'Cannot find iofog instance', callback, obj);
    }
  });
};

var getFogInstanceOptional = function getFogInstanceOptional(props, params, callback) {
  var fogId = _appUtils2.default.getProperty(params, props.fogId);

  _fogManager2.default.findByInstanceId(fogId).then(_appUtils2.default.onFindOptional.bind(null, params, props.setProperty, callback));
};

var findFogInstance = function findFogInstance(props, params, callback) {
  var fogsData = _appUtils2.default.getProperty(params, props.fogsData);

  _fogManager2.default.findByInstanceId(_underscore2.default.pluck(fogsData, props.field)).then(_appUtils2.default.onFindOptional.bind(null, params, props.setProperty, callback));
};

var getFogInstanceForUser = function getFogInstanceForUser(props, params, callback) {
  var userId = _appUtils2.default.getProperty(params, props.userId);

  _fogManager2.default.findByUserId(userId).then(_appUtils2.default.onFind.bind(null, params, props.setProperty, 'Cannot find iofog instance', callback));
};

var getFogList = function getFogList(props, params, callback) {

  _fogManager2.default.getFogList().then(_appUtils2.default.onFind.bind(null, params, props.setProperty, 'Cannot get iofog list', callback));
};

var getFogInstanceDetails = function getFogInstanceDetails(props, params, callback) {
  var instanceId = _appUtils2.default.getProperty(params, props.instanceId);

  _fogManager2.default.getFogInstanceDetails(instanceId).then(_appUtils2.default.onFindOptional.bind(null, params, props.setProperty, callback));
};

var updateFogInstance = function updateFogInstance(props, params, callback) {
  var instanceId = _appUtils2.default.getProperty(params, props.instanceId);

  _fogManager2.default.updateFogConfig(instanceId, props.updatedFog).then(_appUtils2.default.onUpdate.bind(null, params, 'Unable to update iofog instance', callback));
};

exports.default = {
  createFogInstance: createFogInstance,
  createFogInstanceWithUUID: createFogInstanceWithUUID,
  deleteFogInstance: deleteFogInstance,
  getFogInstance: getFogInstance,
  getFogInstanceOptional: getFogInstanceOptional,
  getFogInstanceForUser: getFogInstanceForUser,
  getFogInstanceDetails: getFogInstanceDetails,
  getFogList: getFogList,
  updateFogInstance: updateFogInstance,
  findFogInstance: findFogInstance
};