'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _fogTypeManager = require('../managers/fogTypeManager');

var _fogTypeManager2 = _interopRequireDefault(_fogTypeManager);

var _appUtils = require('../utils/appUtils');

var _appUtils2 = _interopRequireDefault(_appUtils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getFogTypeDetail = function getFogTypeDetail(props, params, callback) {
  var fogTypeId = _appUtils2.default.getProperty(params, props.fogTypeId);

  _fogTypeManager2.default.findFogTypeById(fogTypeId).then(_appUtils2.default.onFind.bind(null, params, props.setProperty, 'Error: Unable to find fogType details', callback));
};

var getFogTypeDetails = function getFogTypeDetails(props, params, callback) {

  _fogTypeManager2.default.findFogTypeById(props.fogTypeId).then(_appUtils2.default.onFind.bind(null, params, props.setProperty, 'Error: Unable to find fogType details', callback));
};

var getFogTypesList = function getFogTypesList(props, params, callback) {

  _fogTypeManager2.default.getFogTypes().then(_appUtils2.default.onFind.bind(null, params, props.setProperty, 'Unable to get Fog Types List', callback));
};

exports.default = {
  getFogTypeDetail: getFogTypeDetail,
  getFogTypeDetails: getFogTypeDetails,
  getFogTypesList: getFogTypesList
};