'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _fogUserManager = require('../managers/fogUserManager');

var _fogUserManager2 = _interopRequireDefault(_fogUserManager);

var _appUtils = require('../utils/appUtils');

var _appUtils2 = _interopRequireDefault(_appUtils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var createFogUser = function createFogUser(props, params, callback) {
  var userId = _appUtils2.default.getProperty(params, props.userId),
      instanceId = _appUtils2.default.getProperty(params, props.instanceId);

  _fogUserManager2.default.create(userId, instanceId).then(_appUtils2.default.onCreate.bind(null, params, props.setProperty, 'Unable to create user for Fog Instance', callback));
};

var deleteFogUserByInstanceId = function deleteFogUserByInstanceId(props, params, callback) {
  var instanceId = _appUtils2.default.getProperty(params, props.instanceId);

  _fogUserManager2.default.deleteByInstanceId(instanceId).then(_appUtils2.default.onDeleteOptional.bind(null, params, callback));
};

var deleteFogUserByInstanceIdAndUserId = function deleteFogUserByInstanceIdAndUserId(props, params, callback) {
  var userId = _appUtils2.default.getProperty(params, props.userId),
      instanceId = _appUtils2.default.getProperty(params, props.instanceId);

  _fogUserManager2.default.deleteByInstanceIdAndUserId(userId, instanceId).then(_appUtils2.default.onDeleteOptional.bind(null, params, callback));
};

var findFogUserByInstanceIdAndUserId = function findFogUserByInstanceIdAndUserId(props, params, callback) {
  var userId = _appUtils2.default.getProperty(params, props.userId),
      instanceId = _appUtils2.default.getProperty(params, props.instanceId);

  _fogUserManager2.default.isUserExist(userId, instanceId).then(_appUtils2.default.onFind.bind(null, params, props.setProperty, 'Unable to find Fog User', callback));
};

var getFogUserByInstanceId = function getFogUserByInstanceId(props, params, callback) {
  var fogId = _appUtils2.default.getProperty(params, props.instanceId);

  _fogUserManager2.default.findByInstanceId(fogId).then(_appUtils2.default.onFind.bind(null, params, props.setProperty, 'Cannot find Fog User', callback));
};

exports.default = {
  createFogUser: createFogUser,
  deleteFogUserByInstanceId: deleteFogUserByInstanceId,
  deleteFogUserByInstanceIdAndUserId: deleteFogUserByInstanceIdAndUserId,
  findFogUserByInstanceIdAndUserId: findFogUserByInstanceIdAndUserId,
  getFogUserByInstanceId: getFogUserByInstanceId
};