'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _fogVersionCommandManager = require('../managers/fogVersionCommandManager');

var _fogVersionCommandManager2 = _interopRequireDefault(_fogVersionCommandManager);

var _appUtils = require('../utils/appUtils');

var _appUtils2 = _interopRequireDefault(_appUtils);

var _constants = require('../constants.js');

var _constants2 = _interopRequireDefault(_constants);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var createVersionCommandByInstanceId = function createVersionCommandByInstanceId(props, params, callback) {
    var instanceId = _appUtils2.default.getProperty(params, props.instanceId),
        versionCommand = _appUtils2.default.getProperty(params, props.versionCommand),
        newCommand = {
        versionCommand: versionCommand,
        iofog_uuid: instanceId
    };

    _fogVersionCommandManager2.default.createVersionCommand(newCommand).then(_appUtils2.default.onCreate.bind(null, params, props.setProperty, 'Unable to create Version Command', callback));
};

var deleteVersionCommandByInstanceId = function deleteVersionCommandByInstanceId(props, params, callback) {
    var instanceId = _appUtils2.default.getProperty(params, props.instanceId);

    _fogVersionCommandManager2.default.deleteByInstanceId(instanceId).then(_appUtils2.default.onDeleteOptional.bind(null, params, callback));
};

var getVersionCommandByInstanceId = function getVersionCommandByInstanceId(props, params, callback) {
    var instanceId = _appUtils2.default.getProperty(params, props.instanceId);

    _fogVersionCommandManager2.default.findByInstanceId(instanceId).then(_appUtils2.default.onFind.bind(null, params, props.setProperty, 'Error: Unable to find version command with this fog', callback));
};

exports.default = {
    createVersionCommandByInstanceId: createVersionCommandByInstanceId,
    deleteVersionCommandByInstanceId: deleteVersionCommandByInstanceId,
    getVersionCommandByInstanceId: getVersionCommandByInstanceId
};