'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _HWInfoManager = require('../managers/HWInfoManager');

var _HWInfoManager2 = _interopRequireDefault(_HWInfoManager);

var _usbInfoManager = require('../managers/usbInfoManager');

var _usbInfoManager2 = _interopRequireDefault(_usbInfoManager);

var _appUtils = require('../utils/appUtils');

var _appUtils2 = _interopRequireDefault(_appUtils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var saveHWInfo = function saveHWInfo(props, params, callback) {

    var info = _appUtils2.default.getProperty(params, props.fogInfo),
        uuid = _appUtils2.default.getProperty(params, props.uuid);

    var config = {
        info: info,
        iofog_uuid: uuid
    };

    _HWInfoManager2.default.upsert(config).then(_appUtils2.default.onCreate.bind(null, params, props.setProperty, 'Unable to save HW Info.', callback));
}; /**
    * @author elukashick
    */

var saveUSBInfo = function saveUSBInfo(props, params, callback) {

    var info = _appUtils2.default.getProperty(params, props.fogInfo),
        uuid = _appUtils2.default.getProperty(params, props.uuid);

    var config = {
        info: info,
        iofog_uuid: uuid
    };

    _usbInfoManager2.default.upsert(config).then(_appUtils2.default.onCreate.bind(null, params, props.setProperty, 'Unable to save USB Info.', callback));
};

var getFogHwInfo = function getFogHwInfo(props, params, callback) {
    var instanceId = _appUtils2.default.getProperty(params, props.instanceId);

    _HWInfoManager2.default.findByInstanceId(instanceId).then(_appUtils2.default.onFindOptional.bind(null, params, props.setProperty, callback));
};

var getFogUsbInfo = function getFogUsbInfo(props, params, callback) {
    var instanceId = _appUtils2.default.getProperty(params, props.instanceId);

    _usbInfoManager2.default.findByInstanceId(instanceId).then(_appUtils2.default.onFindOptional.bind(null, params, props.setProperty, callback));
};

exports.default = {
    saveHWInfo: saveHWInfo,
    saveUSBInfo: saveUSBInfo,
    getFogHwInfo: getFogHwInfo,
    getFogUsbInfo: getFogUsbInfo
};