'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _proxyManager = require('../managers/proxyManager');

var _proxyManager2 = _interopRequireDefault(_proxyManager);

var _appUtils = require('../utils/appUtils');

var _appUtils2 = _interopRequireDefault(_appUtils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var createProxy = function createProxy(props, params, callback) {
    _proxyManager2.default.create(props.proxy).then(_appUtils2.default.onCreate.bind(null, params, props.setProperty, 'Unable to create proxy for Fog Instance', callback));
};

var createOrUpdateExistingProxy = function createOrUpdateExistingProxy(props, params, callback) {};

var deleteProxy = function deleteProxy(props, params, callback) {
    var instanceId = _appUtils2.default.getProperty(params, props.fogInstanceId);

    _proxyManager2.default.deleteByInstanceId(instanceId).then(_appUtils2.default.onDeleteOptional.bind(null, params, callback));
};

var getProxyByInstanceId = function getProxyByInstanceId(props, params, callback) {
    var instanceId = _appUtils2.default.getProperty(params, props.fogInstanceId);

    _proxyManager2.default.findByInstanceId(instanceId).then(_appUtils2.default.onFindOptional.bind(null, params, props.setProperty, callback));
};

var updateProxy = function updateProxy(props, params, callback) {
    var fogInstanceId = _appUtils2.default.getProperty(params, props.fogInstanceId);

    _proxyManager2.default.updateByUuid(fogInstanceId, props.changeObject).then(_appUtils2.default.onUpdate.bind(null, params, 'Unable to update Proxy', callback));
};

exports.default = {
    createProxy: createProxy,
    deleteProxy: deleteProxy,
    getProxyByInstanceId: getProxyByInstanceId,
    updateProxy: updateProxy
};