'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _registryManager = require('../managers/registryManager');

var _registryManager2 = _interopRequireDefault(_registryManager);

var _appUtils = require('../utils/appUtils');

var _appUtils2 = _interopRequireDefault(_appUtils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var findRegistriesByUserId = function findRegistriesByUserId(props, params, param, callback) {
    var userId = _appUtils2.default.getProperty(params, props.userId);

    _registryManager2.default.findByUserId(userId).then(_appUtils2.default.onFind.bind(null, params, props.setProperty, 'Unable to find registries with userId: ' + userId, callback));
};

var listRegistry = function listRegistry(props, params, callback) {
    var userId = _appUtils2.default.getProperty(params, props.userId);

    _registryManager2.default.findByUserId(userId).then(_appUtils2.default.onFindOptional.bind(null, params, props.setProperty, callback));
};

var addRegistry = function addRegistry(props, params, callback) {
    var url = _appUtils2.default.getProperty(params, props.url),
        isPublic = _appUtils2.default.getProperty(params, props.isPublic) === 'true' ? 1 : 0,
        userId = _appUtils2.default.getProperty(params, props.userId),
        username = '',
        password = '',
        email = '';
    if (!isPublic) {
        username = _appUtils2.default.getProperty(params, props.username);
        password = _appUtils2.default.getProperty(params, props.password);
        email = _appUtils2.default.getProperty(params, props.email);
    }

    var registryObj = {
        url: url,
        username: username,
        password: password,
        useremail: email,
        user_id: userId,
        ispublic: isPublic,
        requirescert: 0
    };

    _registryManager2.default.create(registryObj).then(_appUtils2.default.onCreate.bind(null, params, props.setProperty, 'Unable to create Registry.', callback));
};

var deleteRegistry = function deleteRegistry(props, params, callback) {
    _registryManager2.default.deleteById(props.id).then(_appUtils2.default.onDelete.bind(null, params, 'No Registry found', callback));
};

exports.default = {
    findRegistriesByUserId: findRegistriesByUserId,
    listRegistry: listRegistry,
    addRegistry: addRegistry,
    deleteRegistry: deleteRegistry
};