'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _satelliteManager = require('../managers/satelliteManager');

var _satelliteManager2 = _interopRequireDefault(_satelliteManager);

var _appUtils = require('../utils/appUtils');

var _appUtils2 = _interopRequireDefault(_appUtils);

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var findBySatelliteIds = function findBySatelliteIds(props, params, callback) {
  var satellitePortData = _appUtils2.default.getProperty(params, props.satellitePortData);

  _satelliteManager2.default.findBySatelliteIds(_underscore2.default.pluck(satellitePortData, props.field)).then(_appUtils2.default.onFindOptional.bind(null, params, props.setProperty, callback));
};

var getRandomSatellite = function getRandomSatellite(params, callback) {
  var randomNumber = void 0;

  _satelliteManager2.default.findAll().then(function (satellites) {
    if (satellites && satellites.length > 0) {
      randomNumber = Math.round(Math.random() * (satellites.length - 1));
      console.log('Random number ' + randomNumber);
      params.satellite = satellites[randomNumber];
      callback(null, params);
    } else {
      callback('error', 'No Satellite defined');
    }
  });
};

var getSatelliteById = function getSatelliteById(props, params, callback) {
  var satelliteId = _appUtils2.default.getProperty(params, props.satelliteId);

  _satelliteManager2.default.findById(satelliteId).then(_appUtils2.default.onFind.bind(null, params, props.setProperty, 'Cannot find Satellite', callback));
};

exports.default = {
  findBySatelliteIds: findBySatelliteIds,
  getRandomSatellite: getRandomSatellite,
  getSatelliteById: getSatelliteById
};