'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _straceDiagnosticsManager = require('../managers/straceDiagnosticsManager');

var _straceDiagnosticsManager2 = _interopRequireDefault(_straceDiagnosticsManager);

var _appUtils = require('../utils/appUtils');

var _appUtils2 = _interopRequireDefault(_appUtils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var switchStraceForElement = function switchStraceForElement(props, params, callback) {
    if (_appUtils2.default.getProperty(params, props.fogId) == null) {
        return callback('error', 'Can\'t run strace for element without fog');
    }

    var elementData = {
        element_instance_uuid: _appUtils2.default.getProperty(params, props.instanceId),
        straceRun: _appUtils2.default.getProperty(params, props.strace)
    };

    return _straceDiagnosticsManager2.default.updateOrCreateStraceDiagnostics(elementData).then(_appUtils2.default.onUpdateOrCreate.bind(null, params, props.setProperty, 'Unable to switch STrace for Fog Instance', callback));
};

var pushBufferForElements = function pushBufferForElements(props, params, callback) {
    var straceData = _appUtils2.default.getProperty(params, props.straceData);
    Object.keys(straceData).forEach(function (elementId) {
        _straceDiagnosticsManager2.default.pushBufferByElementId(elementId, straceData[elementId]);
    });
    callback(null, params);
};

var popBufferByElementId = function popBufferByElementId(props, params, callback) {
    var elementId = _appUtils2.default.getProperty(params, props.instanceId);

    return _straceDiagnosticsManager2.default.findStraceDiagnosticsAndPopBufferByElementId(elementId).then(_appUtils2.default.onFind.bind(null, params, props.setProperty, 'this instance isn\'t in strace diagnostics list', callback));
};

var getStraceValuesForFog = function getStraceValuesForFog(props, params, callback) {
    var fogId = _appUtils2.default.getProperty(params, props.fogId);

    return _straceDiagnosticsManager2.default.findStraceDiagnosticsStateByFogId(fogId).then(_appUtils2.default.onFindOptional.bind(null, params, props.setProperty, callback));
};

exports.default = {
    switchStraceForElement: switchStraceForElement,
    pushBufferForElements: pushBufferForElements,
    popBufferByElementId: popBufferByElementId,
    getStraceValuesForFog: getStraceValuesForFog
};