'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _streamViewerManager = require('../managers/streamViewerManager');

var _streamViewerManager2 = _interopRequireDefault(_streamViewerManager);

var _appUtils = require('../utils/appUtils');

var _appUtils2 = _interopRequireDefault(_appUtils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var createStreamViewer = function createStreamViewer(props, params, callback) {

  _streamViewerManager2.default.create(props.streamViewerObj).then(_appUtils2.default.onCreate.bind(null, params, props.setProperty, 'Unable to create Stream Viewer object', callback));
};

var getStreamViewerByFogInstanceId = function getStreamViewerByFogInstanceId(props, params, callback) {
  var instanceId = _appUtils2.default.getProperty(params, props.instanceId);

  _streamViewerManager2.default.findByInstanceId(instanceId).then(_appUtils2.default.onFindOptional.bind(null, params, props.setProperty, callback));
};

var deleteStreamViewerByFogInstanceId = function deleteStreamViewerByFogInstanceId(props, params, callback) {
  var instanceId = _appUtils2.default.getProperty(params, props.instanceId);

  _streamViewerManager2.default.deleteByInstanceId(instanceId).then(_appUtils2.default.onDeleteOptional.bind(null, params, callback));
};

exports.default = {
  createStreamViewer: createStreamViewer,
  getStreamViewerByFogInstanceId: getStreamViewerByFogInstanceId,
  deleteStreamViewerByFogInstanceId: deleteStreamViewerByFogInstanceId

};