'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var architecturesImagesFieldsNames = Object.freeze({
    1: 'x86ContainerImage',
    2: 'armContainerImage'
});

var isExistsImageForFogType = function isExistsImageForFogType(fogTypeId, elementImages) {
    var currentFieldName = architecturesImagesFieldsNames[fogTypeId];
    return currentFieldName && elementImages[currentFieldName] !== '';
};

var createImagesListJsonTemplate = function createImagesListJsonTemplate() {
    var imagesList = {};

    Object.keys(architecturesImagesFieldsNames).forEach(function (currentArcType) {
        imagesList[architecturesImagesFieldsNames[currentArcType]] = '';
    });

    return imagesList;
};

var fillImageField = function fillImageField(arcTypeId, imageValue, imagesList) {
    imagesList[architecturesImagesFieldsNames[arcTypeId]] = imageValue;
};

exports.default = {
    architecturesList: architecturesImagesFieldsNames,
    isExistsImageForFogType: isExistsImageForFogType,
    createImagesListJsonTemplate: createImagesListJsonTemplate,
    fillImageField: fillImageField
};