'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _appUtils = require('./appUtils');

var _appUtils2 = _interopRequireDefault(_appUtils);

var _winstonLogs = require('./winstonLogs');

var _winstonLogs2 = _interopRequireDefault(_winstonLogs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ftpClient = require('ftp');
var fs = require('fs');


var sendToFtp = function sendToFtp(props, params, callback) {

    var host = _appUtils2.default.getProperty(params, props.host);
    var port = _appUtils2.default.getProperty(params, props.port);
    var user = _appUtils2.default.getProperty(params, props.user);
    var pass = _appUtils2.default.getProperty(params, props.pass);
    var destDir = _appUtils2.default.getProperty(params, props.destDir);

    var filePath = _appUtils2.default.getProperty(params, props.file);

    var client = new ftpClient();
    var connectionData = {
        host: host,
        port: port,
        user: user,
        password: pass,
        protocol: 'ftp'
    };

    client.on('ready', function () {
        client.put(filePath, destDir + '/' + filePath.split('/').pop(), function (err) {
            if (err) {
                _winstonLogs2.default.warn('Problem with ftp: ' + err);
                client.end();
                callback('error', 'ftp problem');
            } else {
                client.end();
                callback(null, params);
            }
        });
    });
    client.on('error', function (err) {
        _winstonLogs2.default.warn('Problem with ftp: ' + err);
        callback('error', 'ftp problem');
    });

    client.connect(connectionData);
};

exports.default = {
    sendToFtp: sendToFtp
};